com-tecnick-tcpdf

# Class: TCPDF Source Location: /tcpdf.php
### Class Overview
This is a PHP class for generating PDF documents without requiring external extensions. #### Author(s): Nicola Asuni - info@tecnick.com #### Version: 4.8.009 | ### Variables $AliasNbPages $AliasNumPage $annotation_fonts $annots_start_obj_id $annot_obj_id $apxo_obj_id $apxo_start_obj_id $author $AutoPageBreak $barcode $bgcolor $bMargin $booklet $buffer $bufferlen $byterange_string $cache_file_lenght $cache_maxsize_UTF8StringToArray $cache_size_UTF8StringToArray $cache_UTF8StringToArray $cell_height_ratio $cMargin $cntmrk $ColorFlag $compress $CoreFonts $creator $CurOrientation $CurrentFont $currpagegroup $curr_annot_obj_id $customlistindent $default_form_prop $default_monospaced_font $default_table_columns $diffs $diskcache $dpi $DrawColor $embeddedfiles $embedded_start_obj_id $encoding $encrypted $encryption_key $enc_obj_id $endlinex $epsmarker $extgstates $feps $fgcolor $fhPt $FillColor $FontAscent $FontDescent $FontFamily $FontFiles $fontkeys $fontlist $fonts $FontSize $FontSizePt $FontStyle $font_obj_ids $footerlen $footerpos $footer_font $footer_margin $form_action $form_enctype $form_mode $form_obj_id $fwPt $gradients $h $header_font $header_logo $header_logo_width $header_margin $header_string $header_title $hPt $HREF $htmlLinkColorArray $htmlLinkFontStyle $htmlvspace $imagekeys $images $imgscale $img_rb_x $img_rb_y $InFooter $internal_encoding $intmrk $isunicode $javascript $jpeg_quality $js_objects $js_obj_id $js_start_obj_id $k $keywords $l $lasth $last_rc4_key $last_rc4_key_c $LayoutMode $linestyleCap $linestyleDash $linestyleJoin $linestyleWidth $linethrough $LineWidth $links $lispacer $listcount $listindent $listnum $listordered $lisymbol $lMargin $n $newline $newpagegroup $numfonts $numimages $numpages $n_js $n_ocg_print $n_ocg_view $objcopy $offsets $oldcMargin $opencell $openMarkedContent $original_lMargin $original_rMargin $OutlineRoot $outlines $Ovalue $padding $page $PageAnnots $PageBreakTrigger $pagedim $pagegroups $pagelen $PageMode $pageopen $pages $page_obj_id $PDFVersion $premode $print_footer $print_header $Pvalue $radiobutton_groups $radio_groups $re_spaces $rMargin $rtl $sign $signature_data $signature_max_lenght $sig_annot_ref $sig_obj_id $spot_colors $start_transaction_page $state $subject $tagvspaces $tempfontsize $TextColor $textindent $thead $theadMargins $title $tMargin $tmprtl $transfmatrix $transfmatrix_key $transfmrk $underline $ur $ur_annots $ur_document $ur_form $ur_signature $Uvalue $viewer_preferences $visibility $w $wPt $x $y $ZoomMode | ### Methods __construct __destruct AcceptPageBreak addExtGState AddFont addHtmlLink addHTMLVertSpace addJavascriptObject AddLink AddPage AddSpotColor addTOC AliasNbPages AliasNumPage Annotation Arrow arrUTF8ToUTF16BE Bookmark Button Cell CheckBox checkPageBreak Circle Clip Close closeHTMLTagHandler ComboBox commitTransaction convertHTMLColorToDec CoonsPatchMesh Curve deletePage Ellipse empty_string endPage Error Footer formatPageNumber formatTOCPageNumber GetAbsX getAliasNbPages getAliasNumPage getAnnotOptFromJSProp GetArrStringWidth getBarcode getBorderMode getBreakMargin getBuffer getCellCode getCellHeightRatio GetCharWidth getFontBuffer getFontFamily getFontSize getFontSizePt getFontsList getFontStyle getFooterFont getFooterMargin getFormDefaultProp getGDgamma getGraphicVars getGroupPageNo getGroupPageNoFormatted getHeaderData getHeaderFont getHeaderMargin getHtmlDomArray getHTMLUnitToUnits getImageBuffer getImageRBX getImageRBY getImageScale getLastH GetLineWidth getMargins GetNumChars getNumLines getNumPages getObjFilename getOriginalMargins getPage getPageBuffer getPageDimensions getPageGroupAlias getPageHeight getPageNumGroupAlias getPageWidth getPDFData getRemainingWidth getRTL getScaleFactor GetStringWidth GetX GetY get_mqr Gradient Header Image ImageEps ImagePngAlpha IncludeJS intToRoman lastPage Line LinearGradient Link ListBox Ln MirrorH MirrorL MirrorP MirrorV movePage MultiCell objclone Open openHTMLTagHandler Output PageNo PageNoFormatted PieSector pixelsToUnits Polycurve Polygon PolyLine putHtmlListBullet RadialGradient RadioButton readDiskCache Rect RegularPolygon removeSHY rfread rollbackTransaction Rotate RoundedRect Scale ScaleX ScaleXY ScaleY setAlpha SetAuthor SetAutoPageBreak setBarcode SetBooklet setBuffer setCellHeightRatio SetCellPadding SetCompression setContentMark SetCreator SetDefaultMonospacedFont setDefaultTableColumns SetDisplayMode SetDrawColor SetDrawColorArray SetDrawSpotColor setExtGState SetFillColor SetFillColorArray SetFillSpotColor SetFont setFontBuffer SetFontSize setFontSubBuffer setFooter setFooterFont setFooterMargin setFormDefaultProp setGraphicVars setHeader setHeaderData setHeaderFont setHeaderMargin setHtmlLinksStyle setHtmlVSpace setImageBuffer setImageScale setImageSubBuffer setJPEGQuality SetKeywords setLanguageArray setLastH SetLeftMargin SetLineStyle SetLineWidth SetLink setListIndentWidth setLIsymbol SetMargins setOpenCell setPage setPageBuffer setPageFormat setPageMark setPageOrientation setPageUnit setPDFVersion setPrintFooter setPrintHeader SetProtection SetRightMargin setRTL setSignature setSpacesRE SetSubject setTableHeader setTempRTL SetTextColor SetTextColorArray SetTextSpotColor SetTitle SetTopMargin setUserRights setViewerPreferences setVisibility SetX SetXY SetY set_mqr Skew SkewX SkewY StarPolygon startPage startPageGroup startTransaction StartTransform StopTransform swapMargins Text TextField Transform Translate TranslateX TranslateY unhtmlentities UniArrSubString unichr UTF8ArrayToUniArray UTF8ArrSubString utf8Bidi UTF8StringToArray utf8StrRev UTF8ToLatin1 UTF8ToUTF16BE Write write1DBarcode write2DBarcode writeBarcode writeDiskCache writeHTML writeHTMLCell _addfield _beginpage _datastring _datestring _destroy _dochecks _dolinethrough _dolinethroughw _dounderline _dounderlinew _enddoc _endpage _escape _escapetext _freadint _generateencryptionkey _getfontpath _JScolor _md5_16 _newobj _objectkey _out _outarc _outCurve _outLine _outPoint _outRect _Ovalue _parsejpeg _parsepng _putannotsobjs _putannotsrefs _putAPXObject _putbookmarks _putcatalog _putcidfont0 _putEmbeddedFiles _putencryption _putextgstates _putfonts _putfontwidths _putheader _putimages _putinfo _putjavascript _putocg _putpages _putresourcedict _putresources _putshaders _putsignature _putspotcolors _putstream _puttrailer _puttruetypeunicode _putviewerpreferences _putxobjectdict _RC4 _textstring _toJPEG _Uvalue
### Class Details [line 167] This is a PHP class for generating PDF documents without requiring external extensions. TCPDF project (http://www.tcpdf.org) has been originally derived in 2002 from the Public Domain FPDF class by Olivier Plathey (http://www.fpdf.org), but now is almost entirely rewritten. #### Tags:
author: | Nicola Asuni - info@tecnick.com
version: | 4.8.009
link: | http://www.tcpdf.org
name: | TCPDF
license: | LGPL
[ Top ] ### Class Variables #### $AliasNbPages = '{nb}' [line 508] #### Tags:
var: | for total number of pages
access: | protected
Type: | alias
[ Top ] #### $AliasNumPage = '{pnb}' [line 514] #### Tags:
var: | for page number
access: | protected
Type: | alias
[ Top ] #### $annotation_fonts = array() [line 1452] List of fonts used on form fields (fontname => fontkey). #### Tags:
since: | 4.8.001 (2009-09-09)
access: | protected
Type: | mixed
[ Top ] #### $annots_start_obj_id = 200000 [line 1361] Start ID for annotation objects #### Tags:
since: | 4.7.000 (2009-08-29)
access: | protected
Type: | mixed
[ Top ] #### $annot_obj_id = 200000 [line 1368] Max ID of annotation object #### Tags:
since: | 4.7.000 (2009-08-29)
access: | protected
Type: | mixed
[ Top ] #### $apxo_obj_id = 400000 [line 1445] Current ID of appearance streams XObjects #### Tags:
since: | 4.8.001 (2009-09-09)
access: | protected
Type: | mixed
[ Top ] #### $apxo_start_obj_id = 400000 [line 1438] Start ID for appearance streams XObjects #### Tags:
since: | 4.8.001 (2009-09-09)
access: | protected
Type: | mixed
[ Top ] #### $author = '' [line 490] #### Tags:
access: | protected
Type: | author
[ Top ] #### $AutoPageBreak = [line 448] #### Tags:
var: | page breaking
access: | protected
Type: | automatic
[ Top ] #### $barcode = false [line 606] #### Tags:
var: | to print on page footer (only if set).
access: | protected
Type: | Barcode
[ Top ] #### $bgcolor = [line 699] #### Tags:
var: | background color
access: | protected
Type: | current
[ Top ] #### $bMargin = [line 289] #### Tags:
var: | break margin
access: | protected
Type: | page
[ Top ] #### $booklet = false [line 1100] Booklet mode for double-sided pages #### Tags:
since: | 4.2.000 (2008-10-29)
access: | protected
Type: | mixed
[ Top ] #### $buffer = [line 193] #### Tags:
var: | holding in-memory PDF
access: | protected
Type: | buffer
[ Top ] #### $bufferlen = 0 [line 1200] Lenght of the buffer in bytes. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
Type: | mixed
[ Top ] #### $byterange_string = '/ByteRange[0 ********** ********** **********]' [line 1333] ByteRange placemark used during signature process. #### Tags:
since: | 4.6.028 (2009-08-25)
access: | protected
Type: | mixed
[ Top ] #### $cache_file_lenght = array() [line 1256] Array used to store the lenghts of cache files #### Tags:
since: | 4.5.029 (2009-03-19)
access: | protected
Type: | mixed
[ Top ] #### $cache_maxsize_UTF8StringToArray = 8 [line 1284] Maximum size of cache array used for UTF8StringToArray() method. #### Tags:
since: | 4.5.037 (2009-04-07)
access: | protected
Type: | mixed
[ Top ] #### $cache_size_UTF8StringToArray = 0 [line 1291] Current size of cache array used for UTF8StringToArray() method. #### Tags:
since: | 4.5.037 (2009-04-07)
access: | protected
Type: | mixed
[ Top ] #### $cache_UTF8StringToArray = array() [line 1277] Cache array for UTF8StringToArray() method. #### Tags:
since: | 4.5.037 (2009-04-07)
access: | protected
Type: | mixed
[ Top ] #### $cell_height_ratio = K_CELL_HEIGHT_RATIO [line 950] Default cell height ratio. #### Tags:
since: | 3.0.014 (2008-05-23)
access: | protected
Type: | mixed
[ Top ] #### $cMargin = [line 296] #### Tags:
var: | internal padding
access: | public
Type: | cell
[ Top ] #### $cntmrk = array() [line 987] Array used to store content positions inside the pages buffer. keys are the page numbers #### Tags:
since: | 4.6.021 (2009-07-20)
access: | protected
Type: | mixed
[ Top ] #### $ColorFlag = [line 442] #### Tags:
var: | whether fill and text colors are different
access: | protected
Type: | indicates
[ Top ] #### $compress = [line 211] #### Tags:
var: | flag
access: | protected
Type: | compression
[ Top ] #### $CoreFonts = [line 332] #### Tags:
var: | of standard font names
access: | protected
Type: | array
[ Top ] #### $creator = '' [line 502] #### Tags:
access: | protected
Type: | creator
[ Top ] #### $CurOrientation = [line 217] #### Tags:
var: | page orientation (P = Portrait, L = Landscape)
access: | protected
Type: | current
[ Top ] #### $CurrentFont = [line 406] #### Tags:
var: | font info
access: | protected
Type: | current
[ Top ] #### $currpagegroup = [line 908] Contains the alias of the current page group #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $curr_annot_obj_id = 200000 [line 1375] Current ID of annotation object #### Tags:
since: | 4.8.003 (2009-09-15)
access: | protected
Type: | mixed
[ Top ] #### $customlistindent = -1 [line 1122] #### Tags:
var: | PARSER: custom indent amount for lists. Negative value means disabled.
since: | 4.2.007 (2008-11-12)
access: | protected
Type: | HTML
[ Top ] #### $default_form_prop = array('lineWidth'=>1, 'borderStyle'=>'solid', 'fillColor'=>array(255, 255, 255),'strokeColor'=>array(128,128,128)) [line 1389] #### Tags:
access: | protected
Type: | mixed
[ Top ] #### $default_monospaced_font = 'courier' [line 1242] Default monospaced font #### Tags:
since: | 4.5.025 (2009-03-10)
access: | protected
Type: | mixed
[ Top ] #### $default_table_columns = 4 [line 648] #### Tags:
var: | number of columns for html table.
access: | protected
Type: | Default
[ Top ] #### $diffs = array() [line 350] #### Tags:
var: | of encoding differences
access: | protected
Type: | array
[ Top ] #### $diskcache = false [line 1207] If true enables disk caching. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
Type: | mixed
[ Top ] #### $dpi = 72 [line 887] Dot Per Inch Document Resolution (do not change) #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $DrawColor = [line 424] #### Tags:
var: | for drawing color
access: | protected
Type: | commands
[ Top ] #### $embeddedfiles = array() [line 1136] #### Tags:
var: | of files to embedd
since: | 4.4.000 (2008-12-07)
access: | protected
Type: | array
[ Top ] #### $embedded_start_obj_id = 100000 [line 1354] Start ID for embedded file objects #### Tags:
since: | 4.7.000 (2009-08-29)
access: | protected
Type: | mixed
[ Top ] #### $encoding = 'UTF-8' [line 718] #### Tags:
var: | encoding
since: | 1.53.0.TC010
access: | protected
Type: | default
[ Top ] #### $encrypted = [line 748] Indicates whether document is protected #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $encryption_key = [line 802] RC4 encryption key #### Tags:
access: | protected
Type: | mixed
[ Top ] #### $enc_obj_id = [line 776] encryption object id #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $endlinex = 0 [line 1016] End position of the latest inserted line #### Tags:
since: | 3.2.000 (2008-07-01)
access: | protected
Type: | mixed
[ Top ] #### $epsmarker = 'x#!#EPS#!#x' [line 1079] String used to mark the beginning and end of EPS image blocks #### Tags:
since: | 4.1.000 (2008-10-18)
access: | protected
Type: | mixed
[ Top ] #### $extgstates = [line 936] Array of transparency objects and parameters. #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $feps = 0.005 [line 1107] Epsilon value used for float calculations #### Tags:
since: | 4.2.000 (2008-10-29)
access: | protected
Type: | mixed
[ Top ] #### $fgcolor = [line 669] #### Tags:
var: | foreground color
access: | protected
Type: | current
[ Top ] #### $fhPt = [line 241] #### Tags:
var: | of page format in points
access: | protected
Type: | height
[ Top ] #### $FillColor = [line 430] #### Tags:
var: | for filling color
access: | protected
Type: | commands
[ Top ] #### $FontAscent = [line 387] #### Tags:
var: | font ascent (distance between font top and baseline)
since: | 2.8.000 (2007-03-29)
access: | protected
Type: | current
[ Top ] #### $FontDescent = [line 394] #### Tags:
var: | font descent (distance between font bottom and baseline)
since: | 2.8.000 (2007-03-29)
access: | protected
Type: | current
[ Top ] #### $FontFamily = [line 374] #### Tags:
var: | font family
access: | protected
Type: | current
[ Top ] #### $FontFiles = array() [line 344] #### Tags:
var: | of font files
access: | protected
Type: | array
[ Top ] #### $fontkeys = array() [line 1221] Store the font keys. #### Tags:
since: | 4.5.000 (2009-01-02)
access: | protected
Type: | mixed
[ Top ] #### $fontlist = array() [line 663] #### Tags:
var: | a list of available fonts on filesystem.
access: | protected
Type: | store
[ Top ] #### $fonts = array() [line 338] #### Tags:
var: | of used fonts
access: | protected
Type: | array
[ Top ] #### $FontSize = [line 418] #### Tags:
var: | font size in user unit
access: | protected
Type: | current
[ Top ] #### $FontSizePt = [line 412] #### Tags:
var: | font size in points
access: | protected
Type: | current
[ Top ] #### $FontStyle = [line 380] #### Tags:
var: | font style
access: | protected
Type: | current
[ Top ] #### $font_obj_ids = array() [line 1228] Store the font object IDs. #### Tags:
since: | 4.8.001 (2009-09-09)
access: | protected
Type: | mixed
[ Top ] #### $footerlen = array() [line 1002] Array used to store footer lenght of each page. #### Tags:
since: | 4.0.014 (2008-07-29)
access: | protected
Type: | mixed
[ Top ] #### $footerpos = array() [line 994] Array used to store footer positions of each page. #### Tags:
since: | 3.2.000 (2008-07-01)
access: | protected
Type: | mixed
[ Top ] #### $footer_font = [line 594] #### Tags:
var: | font.
access: | protected
Type: | Footer
[ Top ] #### $footer_margin = [line 568] #### Tags:
var: | distance between footer and bottom page margin.
access: | protected
Type: | Minimum
[ Top ] #### $form_action = '' [line 1417] Current form action (used during XHTML rendering) #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $form_enctype = 'application/x-www-form-urlencoded' [line 1424] Current form encryption type (used during XHTML rendering) #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $form_mode = 'post' [line 1431] Current method to submit forms. #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $form_obj_id = array() [line 1382] List of form annotations IDs #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $fwPt = [line 235] #### Tags:
var: | of page format in points
access: | protected
Type: | width
[ Top ] #### $gradients = array() [line 971] Array for storing gradient information. #### Tags:
since: | 3.1.000 (2008-06-09)
access: | protected
Type: | mixed
[ Top ] #### $h = [line 265] #### Tags:
var: | height of page in user unit
access: | protected
Type: | current
[ Top ] #### $header_font = [line 588] #### Tags:
var: | font.
access: | protected
Type: | Header
[ Top ] #### $header_logo = '' [line 624] #### Tags:
var: | image logo.
access: | protected
Type: | Header
[ Top ] #### $header_logo_width = 30 [line 630] #### Tags:
var: | image logo width in mm.
access: | protected
Type: | Header
[ Top ] #### $header_margin = [line 562] #### Tags:
var: | distance between header and top page margin.
access: | protected
Type: | Minimum
[ Top ] #### $header_string = '' [line 642] #### Tags:
var: | to print on document header.
access: | protected
Type: | String
[ Top ] #### $header_title = '' [line 636] #### Tags:
var: | to print as title on document header.
access: | protected
Type: | String
[ Top ] #### $hPt = [line 253] #### Tags:
var: | height of page in points
access: | protected
Type: | current
[ Top ] #### $HREF = array() [line 657] #### Tags:
var: | PARSER: array to store current link and rendering styles.
access: | protected
Type: | HTML
[ Top ] #### $htmlLinkColorArray = array(0, 0, 255) [line 1158] Default color for html links #### Tags:
since: | 4.4.003 (2008-12-09)
access: | protected
Type: | mixed
[ Top ] #### $htmlLinkFontStyle = 'U' [line 1165] Default font style to add to html links #### Tags:
since: | 4.4.003 (2008-12-09)
access: | protected
Type: | mixed
[ Top ] #### $htmlvspace = 0 [line 1058] Count the latest inserted vertical spaces on HTML #### Tags:
since: | 4.0.021 (2008-08-24)
access: | protected
Type: | mixed
[ Top ] #### $imagekeys = array() [line 1193] Store the image keys. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
Type: | mixed
[ Top ] #### $images = array() [line 356] #### Tags:
var: | of used images
access: | protected
Type: | array
[ Top ] #### $imgscale = 1 [line 538] #### Tags:
var: | factor to convert pixels to user units.
author: | Nicola Asuni
since: | 2004-06-14
access: | protected
Type: | adjusting
[ Top ] #### $img_rb_x = [line 522] #### Tags:
var: | corner X coordinate of inserted image
author: | Nicola Asuni
since: | 2002-07-31
access: | protected
Type: | right-bottom
[ Top ] #### $img_rb_y = [line 530] #### Tags:
var: | corner Y coordinate of inserted image
author: | Nicola Asuni
since: | 2002-07-31
access: | protected
Type: | right-bottom
[ Top ] #### $InFooter = false [line 460] #### Tags:
var: | set when processing footer
access: | protected
Type: | flag
[ Top ] #### $internal_encoding = [line 725] #### Tags:
var: | internal encoding
since: | 1.53.0.TC016
access: | protected
Type: | PHP
[ Top ] #### $intmrk = array() [line 979] Array used to store positions inside the pages buffer. keys are the page numbers #### Tags:
since: | 3.2.000 (2008-06-26)
access: | protected
Type: | mixed
[ Top ] #### $isunicode = false [line 546] #### Tags:
var: | set to true when the input text is unicode (require unicode fonts)
author: | Nicola Asuni
since: | 2005-01-02
access: | protected
Type: | boolean
[ Top ] #### $javascript = '' [line 828] javascript code #### Tags:
since: | 2.1.002 (2008-02-12)
access: | protected
Type: | mixed
[ Top ] #### $jpeg_quality = [line 943] Set the default JPEG compression quality (1-100) #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $js_objects = array() [line 1396] Javascript objects array #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $js_obj_id = 300000 [line 1410] Current ID of javascript object #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $js_start_obj_id = 300000 [line 1403] Start ID for javascript objects #### Tags:
since: | 4.8.000 (2009-09-07)
access: | protected
Type: | mixed
[ Top ] #### $k = [line 229] #### Tags:
var: | factor (number of points in user unit)
access: | protected
Type: | scale
[ Top ] #### $keywords = '' [line 496] #### Tags:
access: | protected
Type: | keywords
[ Top ] #### $l = [line 600] #### Tags:
var: | templates.
access: | protected
Type: | Language
[ Top ] #### $lasth = [line 320] #### Tags:
var: | of last cell printed
access: | protected
Type: | height
[ Top ] #### $last_rc4_key = [line 783] last RC4 key encrypted (cached for optimisation) #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $last_rc4_key_c = [line 790] last RC4 computed key #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $LayoutMode = [line 472] #### Tags:
var: | display mode
access: | protected
Type: | layout
[ Top ] #### $linestyleCap = '0 J' [line 1030] PDF string for last line width #### Tags:
since: | 4.0.006 (2008-07-16)
access: | protected
Type: | mixed
[ Top ] #### $linestyleDash = '[] 0 d' [line 1044] PDF string for last line width #### Tags:
since: | 4.0.006 (2008-07-16)
access: | protected
Type: | mixed
[ Top ] #### $linestyleJoin = '0 j' [line 1037] PDF string for last line width #### Tags:
since: | 4.0.006 (2008-07-16)
access: | protected
Type: | mixed
[ Top ] #### $linestyleWidth = '' [line 1023] PDF string for last line width #### Tags:
since: | 4.0.006 (2008-07-16)
access: | protected
Type: | mixed
[ Top ] #### $linethrough = [line 842] line trough state #### Tags:
since: | 2.8.000 (2008-03-19)
access: | protected
Type: | mixed
[ Top ] #### $LineWidth = [line 326] #### Tags:
var: | width in user unit
access: | protected
Type: | line
[ Top ] #### $links = array() [line 368] #### Tags:
var: | of internal links
access: | protected
Type: | array
[ Top ] #### $lispacer = '' [line 711] #### Tags:
var: | for LI tags.
access: | protected
Type: | spacer
[ Top ] #### $listcount = array() [line 681] #### Tags:
var: | PARSER: array count list items on nested lists.
access: | protected
Type: | HTML
[ Top ] #### $listindent = [line 693] #### Tags:
var: | PARSER: indent amount for lists.
access: | protected
Type: | HTML
[ Top ] #### $listnum = 0 [line 687] #### Tags:
var: | PARSER: current list nesting level.
access: | protected
Type: | HTML
[ Top ] #### $listordered = array() [line 675] #### Tags:
var: | PARSER: array of boolean values, true in case of ordered list (OL), false otherwise.
access: | protected
Type: | HTML
[ Top ] #### $lisymbol = '' [line 1072] Symbol used for HTML unordered list items #### Tags:
since: | 4.0.028 (2008-09-26)
access: | protected
Type: | mixed
[ Top ] #### $lMargin = [line 271] #### Tags:
var: | margin
access: | protected
Type: | left
[ Top ] #### $n = [line 181] #### Tags:
var: | object number
access: | protected
Type: | current
[ Top ] #### $newline = true [line 1009] True if a newline is created. #### Tags:
since: | 3.2.000 (2008-07-01)
access: | protected
Type: | mixed
[ Top ] #### $newpagegroup = array() [line 894] Array of page numbers were a new page group was started #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $numfonts = 0 [line 1214] Counts the number of fonts. #### Tags:
since: | 4.5.000 (2009-01-02)
access: | protected
Type: | mixed
[ Top ] #### $numimages = 0 [line 1186] Counts the number of pages. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
Type: | mixed
[ Top ] #### $numpages = 0 [line 1172] Counts the number of pages. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
Type: | mixed
[ Top ] #### $n_js = [line 835] javascript counter #### Tags:
since: | 2.1.002 (2008-02-12)
access: | protected
Type: | mixed
[ Top ] #### $n_ocg_print = [line 922] Print visibility. #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $n_ocg_view = [line 929] View visibility. #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $objcopy = [line 1249] Used to store a cloned copy of the current class object #### Tags:
since: | 4.5.029 (2009-03-19)
access: | protected
Type: | mixed
[ Top ] #### $offsets = [line 187] #### Tags:
var: | of object offsets
access: | protected
Type: | array
[ Top ] #### $oldcMargin = [line 302] #### Tags:
var: | internal padding (previous value)
access: | protected
Type: | cell
[ Top ] #### $opencell = true [line 1129] #### Tags:
var: | true keeps the border open for the cell sides that cross the page.
since: | 4.2.010 (2008-11-14)
access: | protected
Type: | if
[ Top ] #### $openMarkedContent = false [line 1051] True if marked-content sequence is open #### Tags:
since: | 4.0.013 (2008-07-28)
access: | protected
Type: | mixed
[ Top ] #### $original_lMargin = [line 575] #### Tags:
var: | left margin value
since: | 1.53.0.TC013
access: | protected
Type: | original
[ Top ] #### $original_rMargin = [line 582] #### Tags:
var: | right margin value
since: | 1.53.0.TC013
access: | protected
Type: | original
[ Top ] #### $OutlineRoot = [line 818] Outline root for bookmark #### Tags:
since: | 2.1.002 (2008-02-12)
access: | protected
Type: | mixed
[ Top ] #### $outlines = array() [line 811] Outlines for bookmark #### Tags:
since: | 2.1.002 (2008-02-12)
access: | protected
Type: | mixed
[ Top ] #### $Ovalue = [line 762] O entry in pdf document #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $padding = "\x28\xBF\x4E\x5E\x4E\x75\x8A\x41\x64\x00\x4E\x56\xFF\xFA\x01\x08\x2E\x2E\x00\xB6\xD0\x68\x3E\x80\x2F\x0C\xA9\xFE\x64\x53\x69\x7A" [line 796] RC4 padding #### Tags:
access: | protected
Type: | mixed
[ Top ] #### $page = [line 175] #### Tags:
var: | page number
access: | protected
Type: | current
[ Top ] #### $PageAnnots = array() [line 362] #### Tags:
var: | of Annotations in pages
access: | protected
Type: | array
[ Top ] #### $PageBreakTrigger = [line 454] #### Tags:
var: | used to trigger page breaks
access: | protected
Type: | threshold
[ Top ] #### $pagedim = array() [line 223] #### Tags:
var: | that stores page dimensions and graphic status. $this->pagedim[$this->page]['w'] => page_width_in_points $this->pagedim[$this->page]['h'] => height in points $this->pagedim[$this->page]['wk'] => page_width_in_points $this->pagedim[$this->page]['hk'] => height $this->pagedim[$this->page]['tm'] => top_margin $this->pagedim[$this->page]['bm'] => bottom_margin $this->pagedim[$this->page]['lm'] => left_margin $this->pagedim[$this->page]['rm'] => right_margin $this->pagedim[$this->page]['pb'] => auto_page_break $this->pagedim[$this->page]['or'] => page_orientation $this->pagedim[$this->page]['olm'] => original_left_margin $this->pagedim[$this->page]['orm'] => original_right_margin
access: | protected
Type: | array
[ Top ] #### $pagegroups = [line 901] Contains the number of pages of the groups #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $pagelen = array() [line 1179] Array containing page lenghts in bytes. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
Type: | mixed
[ Top ] #### $PageMode = [line 964] A name object specifying how the document should be displayed when opened. #### Tags:
since: | 3.1.000 (2008-06-09)
access: | protected
Type: | mixed
[ Top ] #### $pageopen = array() [line 1235] Store the fage status (true when opened, false when closed). #### Tags:
since: | 4.5.000 (2009-01-02)
access: | protected
Type: | mixed
[ Top ] #### $pages = array() [line 199] #### Tags:
var: | containing pages
access: | protected
Type: | array
[ Top ] #### $page_obj_id = array() [line 1347] ID of page objects #### Tags:
since: | 4.7.000 (2009-08-29)
access: | protected
Type: | mixed
[ Top ] #### $PDFVersion = '1.7' [line 553] #### Tags:
var: | version
since: | 1.5.3
access: | protected
Type: | PDF
[ Top ] #### $premode = false [line 1143] #### Tags:
var: | true when inside html pre tag
since: | 4.4.001 (2008-12-08)
access: | protected
Type: | boolean
[ Top ] #### $print_footer = true [line 618] #### Tags:
var: | true prints footer.
access: | protected
Type: | If
[ Top ] #### $print_header = true [line 612] #### Tags:
var: | true prints header
access: | protected
Type: | If
[ Top ] #### $Pvalue = [line 769] P entry in pdf document #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $radiobutton_groups = array() [line 1459] List of radio buttons parent objects. #### Tags:
since: | 4.8.001 (2009-09-09)
access: | protected
Type: | mixed
[ Top ] #### $radio_groups = array() [line 1466] List of radio group objects IDs #### Tags:
since: | 4.8.001 (2009-09-09)
access: | protected
Type: | mixed
[ Top ] #### $re_spaces = '/[\s]/' [line 1319] Regular expression used to find blank characters used for word-wrapping. #### Tags:
since: | 4.6.006 (2009-04-28)
access: | protected
Type: | mixed
[ Top ] #### $rMargin = [line 283] #### Tags:
var: | margin
access: | protected
Type: | right
[ Top ] #### $rtl = false [line 732] #### Tags:
var: | if the document language is Right-To-Left
since: | 2.0.000
access: | protected
Type: | indicates
[ Top ] #### $sign = false [line 1298] If true enables document signing #### Tags:
since: | 4.6.005 (2009-04-24)
access: | protected
Type: | mixed
[ Top ] #### $signature_data = array() [line 1305] Signature data #### Tags:
since: | 4.6.005 (2009-04-24)
access: | protected
Type: | mixed
[ Top ] #### $signature_max_lenght = 11742 [line 1312] Signature max lenght #### Tags:
since: | 4.6.005 (2009-04-24)
access: | protected
Type: | mixed
[ Top ] #### $sig_annot_ref = '***SIGANNREF*** 0 R' [line 1340] Placemark used during signature process. #### Tags:
since: | 4.6.028 (2009-08-25)
access: | protected
Type: | mixed
[ Top ] #### $sig_obj_id = 0 [line 1326] Signature object ID #### Tags:
since: | 4.6.022 (2009-06-23)
access: | protected
Type: | mixed
[ Top ] #### $spot_colors = array() [line 1065] Array of Spot colors #### Tags:
since: | 4.0.024 (2008-09-12)
access: | protected
Type: | mixed
[ Top ] #### $start_transaction_page = 0 [line 1480] Store page number when startTransaction() is called. #### Tags:
since: | 4.8.006 (2009-09-23)
access: | protected
Type: | mixed
[ Top ] #### $state = [line 205] #### Tags:
var: | document state
access: | protected
Type: | current
[ Top ] #### $subject = '' [line 484] #### Tags:
access: | protected
Type: | subject
[ Top ] #### $tagvspaces = array() [line 1114] Array used for custom vertical spaces for HTML tags #### Tags:
since: | 4.2.001 (2008-10-30)
access: | protected
Type: | mixed
[ Top ] #### $tempfontsize = 10 [line 705] #### Tags:
var: | temporary font size in points.
access: | protected
Type: | Store
[ Top ] #### $TextColor = [line 436] #### Tags:
var: | for text color
access: | protected
Type: | commands
[ Top ] #### $textindent = 0 [line 1473] Text indentation value (used for text-indent CSS attribute) #### Tags:
since: | 4.8.006 (2009-09-23)
access: | protected
Type: | mixed
[ Top ] #### $thead = '' [line 1263] Table header content to be repeated on each new page #### Tags:
since: | 4.5.030 (2009-03-20)
access: | protected
Type: | mixed
[ Top ] #### $theadMargins = array() [line 1270] Margins used for table header. #### Tags:
since: | 4.5.030 (2009-03-20)
access: | protected
Type: | mixed
[ Top ] #### $title = '' [line 478] #### Tags:
access: | protected
Type: | title
[ Top ] #### $tMargin = [line 277] #### Tags:
var: | margin
access: | protected
Type: | top
[ Top ] #### $tmprtl = false [line 739] #### Tags:
var: | to force RTL or LTR string inversion
since: | 2.0.000
access: | protected
Type: | used
[ Top ] #### $transfmatrix = array() [line 1086] Array of transformation matrix #### Tags:
since: | 4.2.000 (2008-10-29)
access: | protected
Type: | mixed
[ Top ] #### $transfmatrix_key = 0 [line 1093] Current key for transformation matrix #### Tags:
since: | 4.8.005 (2009-09-17)
access: | protected
Type: | mixed
[ Top ] #### $transfmrk = array() [line 1151] Array used to store positions of graphics transformation blocks inside the page buffer. keys are the page numbers #### Tags:
since: | 4.4.002 (2008-12-09)
access: | protected
Type: | mixed
[ Top ] #### $underline = [line 400] #### Tags:
var: | flag
access: | protected
Type: | underlining
[ Top ] #### $ur = [line 852] If true enables user's rights on PDF reader #### Tags:
since: | 2.9.000 (2008-03-26)
access: | protected
Type: | mixed
[ Top ] #### $ur_annots = [line 866] Names specifying additional annotation-related usage rights for the document. #### Tags:
since: | 2.9.000 (2008-03-26)
access: | protected
Type: | mixed
[ Top ] #### $ur_document = [line 859] Names specifying additional document-wide usage rights for the document. #### Tags:
since: | 2.9.000 (2008-03-26)
access: | protected
Type: | mixed
[ Top ] #### $ur_form = [line 873] Names specifying additional form-field-related usage rights for the document. #### Tags:
since: | 2.9.000 (2008-03-26)
access: | protected
Type: | mixed
[ Top ] #### $ur_signature = [line 880] Names specifying additional signature-related usage rights for the document. #### Tags:
since: | 2.9.000 (2008-03-26)
access: | protected
Type: | mixed
[ Top ] #### $Uvalue = [line 755] U entry in pdf document #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
Type: | mixed
[ Top ] #### $viewer_preferences = [line 957] PDF viewer preferences. #### Tags:
since: | 3.1.000 (2008-06-09)
access: | protected
Type: | mixed
[ Top ] #### $visibility = 'all' [line 915] Restrict the rendering of some elements to screen or printout. #### Tags:
since: | 3.0.000 (2008-03-27)
access: | protected
Type: | mixed
[ Top ] #### $w = [line 259] #### Tags:
var: | width of page in user unit
access: | protected
Type: | current
[ Top ] #### $wPt = [line 247] #### Tags:
var: | width of page in points
access: | protected
Type: | current
[ Top ] #### $x = [line 308] #### Tags:
var: | horizontal position in user unit for cell positioning
access: | protected
Type: | current
[ Top ] #### $y = [line 314] #### Tags:
var: | vertical position in user unit for cell positioning
access: | protected
Type: | current
[ Top ] #### $ZoomMode = [line 466] #### Tags:
var: | display mode
access: | protected
Type: | zoom
[ Top ] ### Class Methods ### constructor __construct [line 1499]
`TCPDF __construct( [string $orientation = 'P'], [string $unit = 'mm'], [mixed $format = 'A4'], [boolean $unicode = true], [String $encoding = 'UTF-8'], [boolean $diskcache = false])`
This is the class constructor. It allows to set up the page format, the orientation and the measure unit used in all the methods (except for the font sizes). #### Tags:
since: | 1.0
access: | public
#### Parameters:
string | $orientation | page orientation. Possible values are (case insensitive): P or Portrait (default) L or Landscape
string | $unit | User measure unit. Possible values are: pt: point mm: millimeter (default) cm: centimeter in: inch A point equals 1/72 of inch, that is to say about 0.35 mm (an inch being 2.54 cm). This is a very common unit in typography; font sizes are expressed in that unit.
mixed | $format | The format used for pages. It can be either one of the following values (case insensitive) or a custom format in the form of a two-element array containing the width and the height (expressed in the unit given by unit). 4A0 2A0 A0 A1 A2 A3 A4 (default) A5 A6 A7 A8 A9 A10 B0 B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 C10 RA0 RA1 RA2 RA3 RA4 SRA0 SRA1 SRA2 SRA3 SRA4 LETTER LEGAL EXECUTIVE FOLIO
boolean | $unicode | TRUE means that the input text is unicode (default = true)
boolean | $diskcache | if TRUE reduce the RAM memory usage by caching temporary data on filesystem (slower).
String | $encoding | charset encoding; default is UTF-8
[ Top ] ### destructor __destruct [line 1625]
`void __destruct( )`
Default destructor. #### Tags:
since: | 1.53.0.TC016
access: | public
[ Top ] ### method AcceptPageBreak [line 3582]
`boolean AcceptPageBreak( )`
Whenever a page break condition is met, the method is called, and the break is issued or not depending on the returned value. The default implementation returns a value according to the mode selected by SetAutoPageBreak(). This method is called automatically and should not be called directly by the application. #### Tags:
see: | TCPDF::SetAutoPageBreak()
since: | 1.4
access: | public
[ Top ] ### method addExtGState [line 11315]
`void addExtGState( $parms)`
#### Tags:
access: | protected
#### Parameters:
| $parms |
[ Top ] ### method AddFont [line 3134]
`array AddFont( string $family, [string $style = ''], [string $fontfile = ''])`
Imports a TrueType, Type1, core, or CID0 font and makes it available. It is necessary to generate a font definition file first (read /fonts/utils/README.TXT). The definition file (and the font file itself when embedding) must be present either in the current directory or in the one indicated by K_PATH_FONTS if the constant is defined. If it could not be found, the error "Could not include font definition file" is generated. #### Tags:
return: | containing the font data, or false in case of error.
see: | TCPDF::SetFont()
since: | 1.5
access: | public
#### Parameters:
string | $family | Font family. The name can be chosen arbitrarily. If it is a standard family name, it will override the corresponding font.
string | $style | Font style. Possible values are (case insensitive): empty string: regular (default) B: bold I: italic BI or IB: bold italic
string | $fontfile | The font definition file. By default, the name is built from the family and style, in lower case with no spaces.
[ Top ] ### method addHtmlLink [line 7692]
`the addHtmlLink( string $url, string $name, [int $fill = 0], [boolean $firstline = false], [array $color = ''], [string $style = -1])`
Output anchor link. #### Tags:
return: | number of cells used or the remaining text if $firstline = true;
access: | public
#### Parameters:
string | $url | link URL or internal link (i.e.: &lt;a href="#23"&gt;link to page 23&lt;/a&gt;)
string | $name | link name
int | $fill | Indicates if the cell background must be painted (1) or transparent (0). Default value: 0.
boolean | $firstline | if true prints only the first line and return the remaining string.
array | $color | array of RGB text color
string | $style | font style (U, D, B, I)
[ Top ] ### method addHTMLVertSpace [line 14813]
`void addHTMLVertSpace( int $n, [boolean $cell = false], [string $h = ''], [boolean $firstorlast = false], [string $tag = ''], [boolean $closing = false])`
Add vertical spaces if needed. #### Tags:
access: | protected
#### Parameters:
int | $n | number of spaces to add
boolean | $cell | if true add the default cMargin space to each new line (default false).
string | $h | The height of the break. By default, the value equals the height of the last printed cell.
boolean | $firstorlast | if true do not print additional empty lines.
string | $tag | HTML tag to which this space will be applied
boolean | $closing | true if this space will be applied to a closing tag, false otherwise
[ Top ] ### method addJavascriptObject [line 9935]
`void addJavascriptObject( $script, [ $onload = false])`
#### Tags:
access: | public
#### Parameters:
| $script |
| $onload |
[ Top ] ### method AddLink [line 3375]
`void AddLink( )`
Creates a new internal link and returns its identifier. An internal link is a clickable area which directs to another place within the document. The identifier can then be passed to Cell(), Write(), Image() or Link(). The destination is defined with SetLink(). #### Tags:
see: | TCPDF::Cell(), TCPDF::Write(), TCPDF::Image(), TCPDF::Link(), TCPDF::SetLink()
since: | 1.5
access: | public
[ Top ] ### method AddPage [line 2350]
`void AddPage( [string $orientation = ''], [mixed $format = ''])`
Adds a new page to the document. If a page is already present, the Footer() method is called first to output the footer (if enabled). Then the page is added, the current position set to the top-left corner according to the left and top margins (or top-right if in RTL mode), and Header() is called to display the header (if enabled). The origin of the coordinate system is at the top-left corner (or top-right for RTL) and increasing ordinates go downwards. #### Tags:
see: | TCPDF::startPage(), TCPDF::endPage()
since: | 1.0
access: | public
#### Parameters:
string | $orientation | page orientation. Possible values are (case insensitive): P or PORTRAIT (default) L or LANDSCAPE
mixed | $format | The format used for pages. It can be either one of the following values (case insensitive) or a custom format in the form of a two-element array containing the width and the height (expressed in the unit given by unit). 4A0 2A0 A0 A1 A2 A3 A4 (default) A5 A6 A7 A8 A9 A10 B0 B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 C10 RA0 RA1 RA2 RA3 RA4 SRA0 SRA1 SRA2 SRA3 SRA4 LETTER LEGAL EXECUTIVE FOLIO
[ Top ] ### method AddSpotColor [line 2767]
`void AddSpotColor( $name, int $c, int $m, int $y, int $k)`
Defines a new spot color. It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetDrawSpotColor(), TCPDF::SetFillSpotColor(), TCPDF::SetTextSpotColor()
since: | 4.0.024 (2008-09-12)
access: | public
#### Parameters:
int | $c | Cyan color for CMYK. Value between 0 and 255
int | $m | Magenta color for CMYK. Value between 0 and 255
int | $y | Yellow color for CMYK. Value between 0 and 255
int | $k | Key (Black) color for CMYK. Value between 0 and 255
| $name |
[ Top ] ### method addTOC [line 15835]
`void addTOC( [int $page = ''], [string $numbersfont = ''], [string $filler = '.'])`
Output a Table of Content Index (TOC). You can override this method to achieve different styles. #### Tags:
author: | Nicola Asuni
since: | 4.5.000 (2009-01-02)
access: | public
#### Parameters:
int | $page | page number where this TOC should be inserted (leave empty for current page).
string | $numbersfont | set the font for page numbers (please use monospaced font for better alignment).
string | $filler | string used to fill the space between text and page number.
[ Top ] ### method AliasNbPages [line 11123]
`void AliasNbPages( [string $alias = '{nb}'])`
Defines an alias for the total number of pages. It will be substituted as the document is closed. #### Tags:
see: | TCPDF::getAliasNbPages(), TCPDF::PageNo(), TCPDF::Footer()
since: | 1.4
access: | public
#### Parameters:
string | $alias | The alias.
[ Top ] ### method AliasNumPage [line 11150]
`void AliasNumPage( [string $alias = '{pnb}'])`
Defines an alias for the page number. It will be substituted as the document is closed. #### Tags:
see: | TCPDF::getAliasNbPages(), TCPDF::PageNo(), TCPDF::Footer()
since: | 4.5.000 (2009-01-02)
access: | public
#### Parameters:
string | $alias | The alias.
[ Top ] ### method Annotation [line 3431]
`void Annotation( [float $x = ''], [float $y = ''], float $w, float $h, string $text, [array $opt = array('Subtype'=>'Text')], [int $spaces = 0])`
Puts a markup annotation on a rectangular area of the page. !!!!THE ANNOTATION SUPPORT IS NOT YET FULLY IMPLEMENTED !!!! #### Tags:
since: | 4.0.018 (2008-08-06)
access: | public
#### Parameters:
float | $x | Abscissa of the upper-left corner of the rectangle
float | $y | Ordinate of the upper-left corner of the rectangle
float | $w | Width of the rectangle
float | $h | Height of the rectangle
string | $text | annotation text or alternate content
array | $opt | array of options (see section 8.4 of PDF reference 1.7).
int | $spaces | number of spaces on the text to link
[ Top ] ### method Arrow [line 9185]
`void Arrow( float $x0, float $y0, $x1, float $y1, [int $head_style = 0], [float $arm_size = 5], [int $arm_angle = 15])`
Draws a grahic arrow. #### Tags:
author: | Piotr Galecki, Nicola Asuni, Andy Meier
since: | 4.6.018 (2009-07-10)
access: | public
#### Parameters:
float | $x0 | Abscissa of second point.
float | $y0 | Ordinate of first point.
float | $y1 | Ordinate of second point.
int | $head_style | (0 = draw only arrowhead arms, 1 = draw closed arrowhead, but no fill, 2 = closed and filled arrowhead, 3 = filled arrowhead)
float | $arm_size | length of arrowhead arms
int | $arm_angle | angle between an arm and the shaft
| $x1 |
[ Top ] ### method arrUTF8ToUTF16BE [line 7590]
`string arrUTF8ToUTF16BE( array $unicode, [boolean $setbom = true])`
Converts array of UTF-8 characters to UTF16-BE string. Based on: http://www.faqs.org/rfcs/rfc2781.html
       Encoding UTF-16:

       Encoding of a single character from an ISO 10646 character value to
        UTF-16 proceeds as follows. Let U be the character number, no greater
        than 0x10FFFF.

        1) If U < 0x10000, encode U as a 16-bit unsigned integer and
           terminate.

        2) Let U' = U - 0x10000. Because U is less than or equal to 0x10FFFF,
           U' must be less than or equal to 0xFFFFF. That is, U' can be
           represented in 20 bits.

        3) Initialize two 16-bit unsigned integers, W1 and W2, to 0xD800 and
           0xDC00, respectively. These integers each have 10 bits free to
           encode the character value, for a total of 20 bits.

        4) Assign the 10 high-order bits of the 20-bit U' to the 10 low-order
           bits of W1 and the 10 low-order bits of U' to the 10 low-order
           bits of W2. Terminate.

        Graphically, steps 2 through 4 look like:
        U' = yyyyyyyyyyxxxxxxxxxx
        W1 = 110110yyyyyyyyyy
        W2 = 110111xxxxxxxxxx
#### Tags:
author: | Nicola Asuni
see: | TCPDF::UTF8ToUTF16BE()
since: | 2.1.000 (2008-01-08)
access: | protected
#### Parameters:
array | $unicode | array containing UTF-8 unicode values
boolean | $setbom | if true set the Byte Order Mark (BOM = 0xFEFF)
[ Top ] ### method Bookmark [line 9829]
`void Bookmark( $txt, [ $level = 0], [ $y = -1], [ $page = ''])`
#### Tags:
access: | public
#### Parameters:
| $txt |
| $level |
| $y |
| $page |
[ Top ] ### method Button [line 10829]
`void Button( $name, $w, $h, $caption, $action, [ $prop = array()], [ $opt = array()], [ $x = ''], [ $y = ''], [ $js = false])`
#### Tags:
access: | public
#### Parameters:
| $name |
| $w |
| $h |
| $caption |
| $action |
| $prop |
| $opt |
| $x |
| $y |
| $js |
[ Top ] ### method Cell [line 3643]
`void Cell( float $w, [float $h = 0], [string $txt = ''], [mixed $border = 0], [int $ln = 0], [string $align = ''], [int $fill = 0], [mixed $link = ''], [int $stretch = 0], [boolean $ignore_min_height = false])`
Prints a cell (rectangular area) with optional borders, background color and character string. The upper-left corner of the cell corresponds to the current position. The text can be aligned or centered. After the call, the current position moves to the right or to the next line. It is possible to put a link on the text. If automatic page breaking is enabled and the cell goes beyond the limit, a page break is done before outputting. #### Tags:
see: | TCPDF::SetFont(), TCPDF::SetDrawColor(), TCPDF::SetFillColor(), TCPDF::SetTextColor(), TCPDF::SetLineWidth(), TCPDF::AddLink(), TCPDF::Ln(), TCPDF::MultiCell(), TCPDF::Write(), TCPDF::SetAutoPageBreak()
since: | 1.0
access: | public
#### Parameters:
float | $w | Cell width. If 0, the cell extends up to the right margin.
float | $h | Cell height. Default value: 0.
string | $txt | String to print. Default value: empty string.
mixed | $border | Indicates if borders must be drawn around the cell. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
int | $ln | Indicates where the current position should go after the call. Possible values are: 0: to the right (or left for RTL languages) 1: to the beginning of the next line 2: below
string | $align | Allows to center or align the text. Possible values are: L or empty string: left align (default value) C: center R: right align J: justify
int | $fill | Indicates if the cell background must be painted (1) or transparent (0). Default value: 0.
mixed | $link | URL or identifier returned by AddLink().
int | $stretch | stretch carachter mode: 0 = disabled 1 = horizontal scaling only if necessary 2 = forced horizontal scaling 3 = character spacing only if necessary 4 = forced character spacing
boolean | $ignore_min_height | if true ignore automatic minimum height value.
[ Top ] ### method CheckBox [line 10759]
`void CheckBox( $name, $w, [ $checked = false], [ $prop = array()], [ $opt = array()], [ $onvalue = 'Yes'], [ $x = ''], [ $y = ''], [ $js = false])`
#### Tags:
access: | public
#### Parameters:
| $name |
| $w |
| $checked |
| $prop |
| $opt |
| $onvalue |
| $x |
| $y |
| $js |
[ Top ] ### method checkPageBreak [line 3595]
`boolean checkPageBreak( [float $h = 0], [mixed $y = ''], [boolean $addpage = true])`
Add page if needed. #### Tags:
return: | true in case of page break, false otherwise.
since: | 3.2.000 (2008-07-01)
access: | protected
#### Parameters:
float | $h | Cell height. Default value: 0.
mixed | $y | starting y position, leave empty for current position.
boolean | $addpage | if true add a page, otherwise only return the true/false state
[ Top ] ### method Circle [line 8819]
`void Circle( float $x0, float $y0, float $r, [ $astart = 0], [ $afinish = 360], [string $style = ''], [array $line_style = array()], [array $fill_color = array()], [integer $nc = 8], float $astart:, float $afinish:)`
Draws a circle. A circle is formed from n Bezier curves. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
float | $x0 | Abscissa of center point.
float | $y0 | Ordinate of center point.
float | $r | Radius.
float | $astart: | Angle start of draw line. Default value: 0.
float | $afinish: | Angle finish of draw line. Default value: 360.
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. C: Draw close. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of circle. Array like for SetLineStyle. Default value: default line style (empty array).
array | $fill_color | Fill color. Format: array(red, green, blue). Default value: default color (empty array).
integer | $nc | Number of curves used in circle. Default value: 8.
| $astart |
| $afinish |
[ Top ] ### method Clip [line 11578]
`void Clip( float $x, float $y, float $w, float $h)`
Set a rectangular clipping area. #### Tags:
author: | Andreas Würmser, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | protected
#### Parameters:
float | $x | abscissa of the top left corner of the rectangle (or top right corner for RTL mode).
float | $y | ordinate of the top left corner of the rectangle.
float | $w | width of the rectangle.
float | $h | height of the rectangle.
[ Top ] ### method Close [line 2244]
`void Close( )`
Terminates the PDF document. It is not necessary to call this method explicitly because Output() does it automatically. If the document contains no page, AddPage() is called to prevent from getting an invalid document. #### Tags:
see: | TCPDF::Open(), TCPDF::Output()
since: | 1.0
access: | public
[ Top ] ### method closeHTMLTagHandler [line 14476]
`void closeHTMLTagHandler( &$dom, int $key, [boolean $cell = false], array $dom)`
Process closing tags. #### Tags:
access: | protected
#### Parameters:
array | $dom | html dom array
int | $key | current element id
boolean | $cell | if true add the default cMargin space to each new line (default false).
| &$dom |
[ Top ] ### method ComboBox [line 10698]
`void ComboBox( $name, $w, $h, $values, [ $prop = array()], [ $opt = array()], [ $x = ''], [ $y = ''], [ $js = false])`
#### Tags:
access: | public
#### Parameters:
| $name |
| $w |
| $h |
| $values |
| $prop |
| $opt |
| $x |
| $y |
| $js |
[ Top ] ### method commitTransaction [line 15994]
`void commitTransaction( )`
Delete the copy of the current TCPDF object used for undo operation. #### Tags:
since: | 4.5.029 (2009-03-19)
access: | public
[ Top ] ### method convertHTMLColorToDec [line 7725]
`array convertHTMLColorToDec( [string $color = '#FFFFFF'])`
Returns an associative array (keys: R,G,B) from an html color name or a six-digit or three-digit hexadecimal color representation (i.e. #3FE5AA or #7FF). #### Tags:
return: | RGB color or false in case of error.
access: | public
#### Parameters:
string | $color | html color
[ Top ] ### method CoonsPatchMesh [line 11498]
`void CoonsPatchMesh( float $x, float $y, float $w, float $h, [array $col1 = array()], [array $col2 = array()], [array $col3 = array()], [array $col4 = array()], [array $coords = array(0.00,0.0,0.33,0.00,0.67,0.00,1.00,0.00,1.00,0.33,1.00,0.67,1.00,1.00,0.67,1.00,0.33,1.00,0.00,1.00,0.00,0.67,0.00,0.33)], [array $coords_min = 0], [array $coords_max = 1])`
Paints a coons patch mesh. #### Tags:
author: | Andreas Würmser, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | public
#### Parameters:
float | $x | abscissa of the top left corner of the rectangle.
float | $y | ordinate of the top left corner of the rectangle.
float | $w | width of the rectangle.
float | $h | height of the rectangle.
array | $col1 | first color (lower left corner) (RGB components).
array | $col2 | second color (lower right corner) (RGB components).
array | $col3 | third color (upper right corner) (RGB components).
array | $col4 | fourth color (upper left corner) (RGB components).
array | $coords | for one patch mesh: array(float x1, float y1, .... float x12, float y12): 12 pairs of coordinates (normally from 0 to 1) which specify the Bezier control points that define the patch. First pair is the lower left edge point, next is its right control point (control point 2). Then the other points are defined in the order: control point 1, edge point, control point 2 going counter-clockwise around the patch. Last (x12, y12) is the first edge point's left control point (control point 1). for two or more patch meshes: array[number of patches]: arrays with the following keys for each patch: f: where to put that patch (0 = first patch, 1, 2, 3 = right, top and left of precedent patch - I didn't figure this out completely - just try and error ;-) points: 12 pairs of coordinates of the Bezier control points as above for the first patch, 8 pairs of coordinates for the following patches, ignoring the coordinates already defined by the precedent patch (I also didn't figure out the order of these - also: try and see what's happening) colors: must be 4 colors for the first patch, 2 colors for the following patches
array | $coords_min | minimum value used by the coordinates. If a coordinate's value is smaller than this it will be cut to coords_min. default: 0
array | $coords_max | maximum value used by the coordinates. If a coordinate's value is greater than this it will be cut to coords_max. default: 1
[ Top ] ### method Curve [line 8594]
`void Curve( float $x0, float $y0, float $x1, float $y1, float $x2, float $y2, float $x3, float $y3, [string $style = ''], [array $line_style = array()], [array $fill_color = array()])`
Draws a Bezier curve. The Bezier curve is a tangent to the line between the control points at either end of the curve. #### Tags:
see: | TCPDF::SetLineStyle()
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
float | $x0 | Abscissa of start point.
float | $y0 | Ordinate of start point.
float | $x1 | Abscissa of control point 1.
float | $y1 | Ordinate of control point 1.
float | $x2 | Abscissa of control point 2.
float | $y2 | Ordinate of control point 2.
float | $x3 | Abscissa of end point.
float | $y3 | Ordinate of end point.
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of curve. Array like for SetLineStyle. Default value: default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
[ Top ] ### method deletePage [line 15695]
`true deletePage( int $page)`
Remove the specified page. #### Tags:
return: | in case of success, false in case of error.
since: | 4.6.004 (2009-04-23)
access: | public
#### Parameters:
int | $page | page to remove
[ Top ] ### method Ellipse [line 8715]
`void Ellipse( float $x0, float $y0, float $rx, [float $ry = 0], [ $angle = 0], [ $astart = 0], [ $afinish = 360], [string $style = ''], [array $line_style = array()], [array $fill_color = array()], [integer $nc = 8], float $angle:, float $astart:, float $afinish:)`
Draws an ellipse. An ellipse is formed from n Bezier curves. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
float | $x0 | Abscissa of center point.
float | $y0 | Ordinate of center point.
float | $rx | Horizontal radius.
float | $ry | Vertical radius (if ry = 0 then is a circle, see Circle). Default value: 0.
float | $angle: | Angle oriented (anti-clockwise). Default value: 0.
float | $astart: | Angle start of draw line. Default value: 0.
float | $afinish: | Angle finish of draw line. Default value: 360.
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. C: Draw close. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of ellipse. Array like for SetLineStyle. Default value: default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
integer | $nc | Number of curves used in ellipse. Default value: 8.
| $angle |
| $astart |
| $afinish |
[ Top ] ### method empty_string [line 16048]
`boolean empty_string( srting $str)`
Determine whether a string is empty. #### Tags:
return: | true if string is empty
since: | 4.5.044 (2009-04-16)
access: | public
#### Parameters:
srting | $str | string to be checked
[ Top ] ### method endPage [line 2369]
`void endPage( )`
Terminate the current page #### Tags:
see: | TCPDF::startPage(), TCPDF::AddPage()
since: | 4.2.010 (2008-11-14)
access: | protected
[ Top ] ### method Error [line 2216]
`void Error( string $msg)`
This method is automatically called in case of fatal error; it simply outputs the message and halts the execution. An inherited class may override it to customize the error handling but should always halt the script, or the resulting document would probably be invalid. 2004-06-11 :: Nicola Asuni : changed bold tag with strong #### Tags:
since: | 1.0
access: | public
#### Parameters:
string | $msg | The error message
[ Top ] ### method Footer [line 2608]
`void Footer( )`
This method is used to render the page footer. It is automatically called by AddPage() and could be overwritten in your own inherited class. #### Tags:
access: | public
[ Top ] ### method formatPageNumber [line 11227]
`void formatPageNumber( int $num)`
Format the page numbers. This method can be overriden for custom formats. #### Tags:
since: | 4.2.005 (2008-11-06)
access: | protected
#### Parameters:
int | $num | page number
[ Top ] ### method formatTOCPageNumber [line 11239]
`void formatTOCPageNumber( int $num)`
Format the page numbers on the Table Of Content. This method can be overriden for custom formats. #### Tags:
see: | TCPDF::addTOC()
since: | 4.5.001 (2009-01-04)
access: | protected
#### Parameters:
int | $num | page number
[ Top ] ### method GetAbsX [line 5174]
`float GetAbsX( )`
Returns the absolute X value of current position. #### Tags:
see: | TCPDF::SetX(), TCPDF::GetY(), TCPDF::SetY()
since: | 1.2
access: | public
[ Top ] ### method getAliasNbPages [line 11135]
`string getAliasNbPages( )`
Returns the string alias used for the total number of pages. If the current font is unicode type, the returned string is surrounded by additional curly braces. #### Tags:
see: | TCPDF::AliasNbPages(), TCPDF::PageNo(), TCPDF::Footer()
since: | 4.0.018 (2008-08-08)
access: | public
[ Top ] ### method getAliasNumPage [line 11163]
`string getAliasNumPage( )`
Returns the string alias used for the page number. If the current font is unicode type, the returned string is surrounded by additional curly braces. #### Tags:
see: | TCPDF::AliasNbPages(), TCPDF::PageNo(), TCPDF::Footer()
since: | 4.5.000 (2009-01-02)
access: | public
[ Top ] ### method getAnnotOptFromJSProp [line 10066]
`void getAnnotOptFromJSProp( $prop)`
#### Tags:
access: | protected
#### Parameters:
| $prop |
[ Top ] ### method GetArrStringWidth [line 3046]
`int GetArrStringWidth( string $sa, [string $fontname = ''], [string $fontstyle = ''], [float $fontsize = 0])`
Returns the string length of an array of chars in user unit. A font must be selected. #### Tags:
return: | string length
author: | Nicola Asuni
since: | 2.4.000 (2008-03-06)
access: | public
#### Parameters:
string | $sa | The array of chars whose total length is to be computed
string | $fontname | Family font. It can be either a name defined by AddFont() or one of the standard families. It is also possible to pass an empty string, in that case, the current family is retained.
string | $fontstyle | Font style. Possible values are (case insensitive): empty string: regular B: bold I: italic U: underline D: line trough or any combination. The default value is regular.
float | $fontsize | Font size in points. The default value is the current size.
[ Top ] ### method getBarcode [line 12043]
`string getBarcode( )`
Get current barcode. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getBorderMode [line 4092]
`border getBorderMode( mixed $border, [string $position = 'start'])`
Get the border mode accounting for multicell position (opens bottom side of multicell crossing pages) #### Tags:
return: | mode
since: | 4.4.002 (2008-12-09)
access: | protected
#### Parameters:
mixed | $border | Indicates if borders must be drawn around the cell block. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
string | $position | multicell position: 'start', 'middle', 'end'
[ Top ] ### method getBreakMargin [line 1947]
`int getBreakMargin( [int $pagenum = ''])`
Returns the page break margin. #### Tags:
return: | page break margin.
author: | Nicola Asuni
see: | TCPDF::getPageDimensions()
since: | 1.5.2
access: | public
#### Parameters:
int | $pagenum | page number (empty = current page)
[ Top ] ### method getBuffer [line 15381]
`string getBuffer( )`
Get buffer content. #### Tags:
return: | buffer content
since: | 4.5.000 (2009-01-02)
access: | protected
[ Top ] ### method getCellCode [line 3695]
`void getCellCode( float $w, [float $h = 0], [string $txt = ''], [mixed $border = 0], [int $ln = 0], [string $align = ''], [int $fill = 0], [mixed $link = ''], [int $stretch = 0], [boolean $ignore_min_height = false])`
Returns the PDF string code to print a cell (rectangular area) with optional borders, background color and character string. The upper-left corner of the cell corresponds to the current position. The text can be aligned or centered. After the call, the current position moves to the right or to the next line. It is possible to put a link on the text. If automatic page breaking is enabled and the cell goes beyond the limit, a page break is done before outputting. #### Tags:
see: | TCPDF::Cell()
since: | 1.0
access: | protected
#### Parameters:
float | $w | Cell width. If 0, the cell extends up to the right margin.
float | $h | Cell height. Default value: 0.
string | $txt | String to print. Default value: empty string.
mixed | $border | Indicates if borders must be drawn around the cell. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
int | $ln | Indicates where the current position should go after the call. Possible values are: 0: to the right (or left for RTL languages) 1: to the beginning of the next line 2: below Putting 1 is equivalent to putting 0 and calling Ln() just after. Default value: 0.
string | $align | Allows to center or align the text. Possible values are: L or empty string: left align (default value) C: center R: right align J: justify
int | $fill | Indicates if the cell background must be painted (1) or transparent (0). Default value: 0.
mixed | $link | URL or identifier returned by AddLink().
int | $stretch | stretch carachter mode: 0 = disabled 1 = horizontal scaling only if necessary 2 = forced horizontal scaling 3 = character spacing only if necessary 4 = forced character spacing
boolean | $ignore_min_height | if true ignore automatic minimum height value.
[ Top ] ### method getCellHeightRatio [line 11401]
`void getCellHeightRatio( )`
#### Tags:
access: | public
[ Top ] ### method GetCharWidth [line 3073]
`int GetCharWidth( int $char)`
Returns the length of the char in user unit for the current font. #### Tags:
return: | char width
author: | Nicola Asuni
since: | 2.4.000 (2008-03-06)
access: | public
#### Parameters:
int | $char | The char code whose length is to be returned
[ Top ] ### method getFontBuffer [line 15541]
`string getFontBuffer( string $font)`
Get font buffer content. #### Tags:
return: | font buffer content or false in case of error
since: | 4.5.000 (2009-01-02)
access: | protected
#### Parameters:
string | $font | font key
[ Top ] ### method getFontFamily [line 12517]
`string getFontFamily( )`
Returns the current font family name. #### Tags:
return: | current font family name
since: | 4.3.008 (2008-12-05)
access: | public
[ Top ] ### method getFontSize [line 12497]
`current getFontSize( )`
Returns the current font size. #### Tags:
return: | font size
since: | 3.2.000 (2008-06-23)
access: | public
[ Top ] ### method getFontSizePt [line 12507]
`current getFontSizePt( )`
Returns the current font size in points unit. #### Tags:
return: | font size in points unit
since: | 3.2.000 (2008-06-23)
access: | public
[ Top ] ### method getFontsList [line 3112]
`void getFontsList( )`
Fill the list of available fonts ($this->fontlist). #### Tags:
since: | 4.0.013 (2008-07-28)
access: | protected
[ Top ] ### method getFontStyle [line 12527]
`string getFontStyle( )`
Returns the current font style. #### Tags:
return: | current font style
since: | 4.3.008 (2008-12-05)
access: | public
[ Top ] ### method getFooterFont [line 7651]
`array() getFooterFont( )`
Get Footer font. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getFooterMargin [line 2522]
`float getFooterMargin( )`
Returns footer margin in user units. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getFormDefaultProp [line 10441]
`void getFormDefaultProp( )`
#### Tags:
access: | public
[ Top ] ### method getGDgamma [line 5117]
`void getGDgamma( float $v)`
Correct the gamma value to be used with GD library #### Tags:
since: | 4.3.007 (2008-12-04)
access: | protected
#### Parameters:
float | $v | the gamma value to be corrected
[ Top ] ### method getGraphicVars [line 15249]
`array getGraphicVars( )`
Returns current graphic variables as array. #### Tags:
return: | graphic variables
since: | 4.2.010 (2008-11-14)
access: | protected
[ Top ] ### method getGroupPageNo [line 11176]
`void getGroupPageNo( )`
#### Tags:
access: | public
[ Top ] ### method getGroupPageNoFormatted [line 11186]
`void getGroupPageNoFormatted( )`
Returns the current group page number formatted as a string. #### Tags:
see: | PaneNo(), TCPDF::formatPageNumber()
since: | 4.3.003 (2008-11-18)
access: | public
[ Top ] ### method getHeaderData [line 2477]
`array() getHeaderData( )`
Returns header data: $ret['logo'] = logo image $ret['logo_width'] = width of the image logo in user units $ret['title'] = header title $ret['string'] = header description string #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getHeaderFont [line 7631]
`array() getHeaderFont( )`
Get header font. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getHeaderMargin [line 2502]
`float getHeaderMargin( )`
Returns header margin in user units. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getHtmlDomArray [line 12563]
`array getHtmlDomArray( string $html)`
Returns the HTML DOM array. $dom[$key]['tag'] = true if tag, false otherwise; $dom[$key]['value'] = tag name or text; $dom[$key]['opening'] = true if opening tag, false otherwise; $dom[$key]['attribute'] = array of attributes (attribute name is the key); $dom[$key]['style'] = array of style attributes (attribute name is the key); $dom[$key]['parent'] = id of parent element; $dom[$key]['fontname'] = font family name; $dom[$key]['fontstyle'] = font style; $dom[$key]['fontsize'] = font size in points; $dom[$key]['bgcolor'] = RGB array of background color; $dom[$key]['fgcolor'] = RGB array of foreground color; $dom[$key]['width'] = width in pixels; $dom[$key]['height'] = height in pixels; $dom[$key]['align'] = text alignment; $dom[$key]['cols'] = number of colums in table; $dom[$key]['rows'] = number of rows in table; #### Tags:
since: | 3.2.000 (2008-06-20)
access: | protected
#### Parameters:
string | $html | html code
[ Top ] ### method getHTMLUnitToUnits [line 14968]
`float getHTMLUnitToUnits( string $htmlval, [string $refsize = 1], [string $defaultunit = 'px'], [ $points = false], boolean $point)`
convert html string containing value and unit of measure to user's units or points. #### Tags:
return: | value in user's unit or point if $points=true
since: | 4.4.004 (2008-12-10)
access: | public
#### Parameters:
string | $htmlval | string containing values and unit
string | $refsize | reference value in points
string | $defaultunit | default unit (can be one of the following: %, em, ex, px, in, mm, pc, pt).
boolean | $point | if true returns points, otherwise returns value in user's units
| $points |
[ Top ] ### method getImageBuffer [line 15483]
`string getImageBuffer( string $image)`
Get image buffer content. #### Tags:
return: | image buffer content or false in case of error
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
string | $image | image key
[ Top ] ### method getImageRBX [line 2548]
`float getImageRBX( )`
Return the right-bottom (or left-bottom for RTL) corner X coordinate of last inserted image #### Tags:
access: | public
[ Top ] ### method getImageRBY [line 2557]
`float getImageRBY( )`
Return the right-bottom (or left-bottom for RTL) corner Y coordinate of last inserted image #### Tags:
access: | public
[ Top ] ### method getImageScale [line 1886]
`float getImageScale( )`
Returns the adjusting factor to convert pixels to user units. #### Tags:
return: | adjusting factor to convert pixels to user units.
author: | Nicola Asuni
since: | 1.5.2
access: | public
[ Top ] ### method getLastH [line 1864]
`last getLastH( )`
Get the last cell height. #### Tags:
return: | cell height
since: | 4.0.017 (2008-08-05)
access: | public
[ Top ] ### method GetLineWidth [line 8308]
`int GetLineWidth( )`
Returns the current the line width. #### Tags:
return: | Line width
see: | TCPDF::Line(), TCPDF::SetLineWidth()
since: | 2.1.000 (2008-01-07)
access: | public
[ Top ] ### method getMargins [line 12460]
`array getMargins( )`
Returns an array containing current margins: #### Tags:
return: | containing all margins measures
since: | 3.2.000 (2008-06-23)
access: | public
[ Top ] ### method GetNumChars [line 3100]
`int GetNumChars( string $s)`
Returns the numbero of characters in a string. #### Tags:
return: | number of characters
since: | 2.0.0001 (2008-01-07)
access: | public
#### Parameters:
string | $s | The input string.
[ Top ] ### method getNumLines [line 4171]
`int getNumLines( string $txt, [float $w = 0])`
This method returns the estimated number of lines required to print the text. #### Tags:
return: | Return the estimated number of lines.
since: | 4.5.011
access: | public
#### Parameters:
string | $txt | text to print
float | $w | width of cell. If 0, they extend up to the right margin of the page.
[ Top ] ### method getNumPages [line 2337]
`int getNumPages( )`
Get the total number of insered pages. #### Tags:
return: | number of pages
see: | TCPDF::setPage(), TCPDF::getPage(), lastpage()
since: | 2.1.000 (2008-01-07)
access: | public
[ Top ] ### method getObjFilename [line 15313]
`void getObjFilename( $name, string $prefix)`
Returns a temporary filename for caching object on filesystem. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
string | $prefix | prefix to add to filename return string filename.
| $name |
[ Top ] ### method getOriginalMargins [line 12483]
`array getOriginalMargins( )`
Returns an array containing original margins: #### Tags:
return: | containing all margins measures
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getPage [line 2325]
`int getPage( )`
Get current document page number. #### Tags:
return: | page number
see: | TCPDF::setPage(), lastpage(), TCPDF::getNumPages()
since: | 2.1.000 (2008-01-07)
access: | public
[ Top ] ### method getPageBuffer [line 15424]
`string getPageBuffer( int $page)`
Get page buffer content. #### Tags:
return: | page buffer content or false in case of error
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
int | $page | page number
[ Top ] ### method getPageDimensions [line 1899]
`array getPageDimensions( [int $pagenum = ''])`
Returns an array of page dimensions: $this->pagedim[$this->page]['w'] => page_width_in_points $this->pagedim[$this->page]['h'] => height in points $this->pagedim[$this->page]['wk'] => page_width_in_points $this->pagedim[$this->page]['hk'] => height $this->pagedim[$this->page]['tm'] => top_margin $this->pagedim[$this->page]['bm'] => bottom_margin $this->pagedim[$this->page]['lm'] => left_margin $this->pagedim[$this->page]['rm'] => right_margin $this->pagedim[$this->page]['pb'] => auto_page_break $this->pagedim[$this->page]['or'] => page_orientation $this->pagedim[$this->page]['olm'] => original_left_margin $this->pagedim[$this->page]['orm'] => original_right_margin #### Tags:
return: | of page dimensions.
author: | Nicola Asuni
since: | 4.5.027 (2009-03-16)
access: | public
#### Parameters:
int | $pagenum | page number (empty = current page)
[ Top ] ### method getPageGroupAlias [line 11198]
`void getPageGroupAlias( )`
#### Tags:
access: | public
[ Top ] ### method getPageHeight [line 1931]
`int getPageHeight( [int $pagenum = ''])`
Returns the page height in units. #### Tags:
return: | page height.
author: | Nicola Asuni
see: | TCPDF::getPageDimensions()
since: | 1.5.2
access: | public
#### Parameters:
int | $pagenum | page number (empty = current page)
[ Top ] ### method getPageNumGroupAlias [line 11213]
`void getPageNumGroupAlias( )`
#### Tags:
access: | public
[ Top ] ### method getPageWidth [line 1915]
`int getPageWidth( [int $pagenum = ''])`
Returns the page width in units. #### Tags:
return: | page width.
author: | Nicola Asuni
see: | TCPDF::getPageDimensions()
since: | 1.5.2
access: | public
#### Parameters:
int | $pagenum | page number (empty = current page)
[ Top ] ### method getPDFData [line 7674]
`void getPDFData( )`
Returns the PDF data. #### Tags:
access: | public
[ Top ] ### method getRemainingWidth [line 4532]
`int getRemainingWidth( )`
Returns the remaining width between the current position and margins. #### Tags:
return: | Return the remaining width
access: | protected
[ Top ] ### method getRTL [line 1827]
`boolean getRTL( )`
Return the RTL status #### Tags:
since: | 4.0.012 (2008-07-24)
access: | public
[ Top ] ### method getScaleFactor [line 1961]
`int getScaleFactor( )`
Returns the scale factor (number of points in user unit). #### Tags:
return: | scale factor.
author: | Nicola Asuni
since: | 1.5.2
access: | public
[ Top ] ### method GetStringWidth [line 3031]
`int GetStringWidth( string $s, [string $fontname = ''], [string $fontstyle = ''], [float $fontsize = 0])`
Returns the length of a string in user unit. A font must be selected. #### Tags:
return: | string length
author: | Nicola Asuni
since: | 1.2
access: | public
#### Parameters:
string | $s | The string whose length is to be computed
string | $fontname | Family font. It can be either a name defined by AddFont() or one of the standard families. It is also possible to pass an empty string, in that case, the current family is retained.
string | $fontstyle | Font style. Possible values are (case insensitive): empty string: regular B: bold I: italic U: underline D: line trough or any combination. The default value is regular.
float | $fontsize | Font size in points. The default value is the current size.
[ Top ] ### method GetX [line 5158]
`float GetX( )`
Returns the relative X value of current position. The value is relative to the left border for LTR languages and to the right border for RTL languages. #### Tags:
see: | TCPDF::SetX(), TCPDF::GetY(), TCPDF::SetY()
since: | 1.2
access: | public
[ Top ] ### method GetY [line 5185]
`float GetY( )`
Returns the ordinate of the current position. #### Tags:
see: | TCPDF::SetY(), TCPDF::GetX(), TCPDF::SetX()
since: | 1.0
access: | public
[ Top ] ### method get_mqr [line 4877]
`Returns get_mqr( )`
Gets the current active configuration setting of magic_quotes_runtime (if the get_magic_quotes_runtime function exist) #### Tags:
return: | 0 if magic quotes runtime is off or get_magic_quotes_runtime doesn't exist, 1 otherwise.
since: | 4.6.025 (2009-08-17)
access: | public
[ Top ] ### method Gradient [line 11601]
`void Gradient( int $type, array $col1, array $col2, array $coords)`
Output gradient. #### Tags:
author: | Andreas Würmser, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | protected
#### Parameters:
int | $type | type of gradient.
array | $col1 | first color (RGB components).
array | $col2 | second color (RGB components).
array | $coords | array of coordinates.
[ Top ] ### method Header [line 2566]
`void Header( )`
This method is used to render the page header. It is automatically called by AddPage() and could be overwritten in your own inherited class. #### Tags:
access: | public
[ Top ] ### method Image [line 4655]
`image Image( string $file, [float $x = ''], [float $y = ''], [float $w = 0], [float $h = 0], [string $type = ''], [mixed $link = ''], [string $align = ''], [boolean $resize = false], [int $dpi = 300], [string $palign = ''], [boolean $ismask = false], [mixed $imgmask = false], [mixed $border = 0], [boolean $fitbox = false], [boolean $hidden = false])`
Puts an image in the page. The upper-left corner must be given. The dimensions can be specified in different ways: explicit width and height (expressed in user unit) one explicit dimension, the other being calculated automatically in order to keep the original proportions no explicit dimension, in which case the image is put at 72 dpi Supported formats are JPEG and PNG images whitout GD library and all images supported by GD: GD, GD2, GD2PART, GIF, JPEG, PNG, BMP, XBM, XPM; The format can be specified explicitly or inferred from the file extension. It is possible to put a link on the image. Remark: if an image is used several times, only one copy will be embedded in the file. #### Tags:
return: | information
since: | 1.1
access: | public
#### Parameters:
string | $file | Name of the file containing the image.
float | $x | Abscissa of the upper-left corner.
float | $y | Ordinate of the upper-left corner.
float | $w | Width of the image in the page. If not specified or equal to zero, it is automatically calculated.
float | $h | Height of the image in the page. If not specified or equal to zero, it is automatically calculated.
string | $type | Image format. Possible values are (case insensitive): JPEG and PNG (whitout GD library) and all images supported by GD: GD, GD2, GD2PART, GIF, JPEG, PNG, BMP, XBM, XPM;. If not specified, the type is inferred from the file extension.
mixed | $link | URL or identifier returned by AddLink().
string | $align | Indicates the alignment of the pointer next to image insertion relative to image height. The value can be: T: top-right for LTR or top-left for RTL M: middle-right for LTR or middle-left for RTL B: bottom-right for LTR or bottom-left for RTL N: next line
boolean | $resize | If true resize (reduce) the image to fit $w and $h (requires GD library).
int | $dpi | dot-per-inch resolution used on resize
string | $palign | Allows to center or align the image on the current line. Possible values are: L : left align C : center R : right align '' : empty string : left for LTR or right for RTL
boolean | $ismask | true if this image is a mask, false otherwise
mixed | $imgmask | image object returned by this function or false
mixed | $border | Indicates if borders must be drawn around the image. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
boolean | $fitbox | If true scale image dimensions proportionally to fit within the ($w, $h) box.
boolean | $hidden | if true do not display the image.
[ Top ] ### method ImageEps [line 11773]
`void ImageEps( string $file, [float $x = ''], [float $y = ''], [float $w = 0], [float $h = 0], [mixed $link = ''], [boolean $useBoundingBox = true], [string $align = ''], [string $palign = ''], [mixed $border = 0])`
Embed vector-based Adobe Illustrator (AI) or AI-compatible EPS files. Only vector drawing is supported, not text or bitmap. Although the script was successfully tested with various AI format versions, best results are probably achieved with files that were exported in the AI3 format (tested with Illustrator CS2, Freehand MX and Photoshop CS2). #### Tags:
author: | Valentin Schmidt, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | public
#### Parameters:
string | $file | Name of the file containing the image.
float | $x | Abscissa of the upper-left corner.
float | $y | Ordinate of the upper-left corner.
float | $w | Width of the image in the page. If not specified or equal to zero, it is automatically calculated.
float | $h | Height of the image in the page. If not specified or equal to zero, it is automatically calculated.
mixed | $link | URL or identifier returned by AddLink().
string | $align | Indicates the alignment of the pointer next to image insertion relative to image height. The value can be: T: top-right for LTR or top-left for RTL M: middle-right for LTR or middle-left for RTL B: bottom-right for LTR or bottom-left for RTL N: next line
string | $palign | Allows to center or align the image on the current line. Possible values are: L : left align C : center R : right align '' : empty string : left for LTR or right for RTL
mixed | $border | Indicates if borders must be drawn around the image. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
boolean | $useBoundingBox | useBoundingBox specifies whether to position the bounding box (true) or the complete canvas (false) at location (x,y). Default value is true.
[ Top ] ### method ImagePngAlpha [line 5073]
`void ImagePngAlpha( string $file, [float $x = ''], [float $y = ''], [float $w = 0], [float $h = 0], [string $type = ''], [mixed $link = ''], [string $align = ''], [boolean $resize = false], [int $dpi = 300], [string $palign = ''])`
Extract info from a PNG image with alpha channel using the GD library. #### Tags:
author: | Valentin Schmidt, Nicola Asuni
see: | TCPDF::Image()
since: | 4.3.007 (2008-12-04)
access: | protected
#### Parameters:
string | $file | Name of the file containing the image.
float | $x | Abscissa of the upper-left corner.
float | $y | Ordinate of the upper-left corner.
float | $w | Width of the image in the page. If not specified or equal to zero, it is automatically calculated.
float | $h | Height of the image in the page. If not specified or equal to zero, it is automatically calculated.
string | $type | Image format. Possible values are (case insensitive): JPEG and PNG (whitout GD library) and all images supported by GD: GD, GD2, GD2PART, GIF, JPEG, PNG, BMP, XBM, XPM;. If not specified, the type is inferred from the file extension.
mixed | $link | URL or identifier returned by AddLink().
string | $align | Indicates the alignment of the pointer next to image insertion relative to image height. The value can be: T: top-right for LTR or top-left for RTL M: middle-right for LTR or middle-left for RTL B: bottom-right for LTR or bottom-left for RTL N: next line
boolean | $resize | If true resize (reduce) the image to fit $w and $h (requires GD library).
int | $dpi | dot-per-inch resolution used on resize
string | $palign | Allows to center or align the image on the current line. Possible values are: L : left align C : center R : right align '' : empty string : left for LTR or right for RTL
[ Top ] ### method IncludeJS [line 9922]
`void IncludeJS( $script)`
#### Tags:
access: | public
#### Parameters:
| $script |
[ Top ] ### method intToRoman [line 15042]
`string intToRoman( int $number)`
Returns the Roman representation of an integer number #### Tags:
return: | roman representation of the specified number
since: | 4.4.004 (2008-12-10)
access: | public
#### Parameters:
int | $number | number to convert
[ Top ] ### method lastPage [line 2314]
`void lastPage( [boolean $resetmargins = false])`
Reset pointer to the last document page. #### Tags:
see: | TCPDF::setPage(), TCPDF::getPage(), TCPDF::getNumPages()
since: | 2.0.000 (2008-01-04)
access: | public
#### Parameters:
boolean | $resetmargins | if true reset left, right, top margins and Y position.
[ Top ] ### method Line [line 8461]
`void Line( float $x1, float $y1, float $x2, float $y2, [array $style = array()])`
Draws a line between two points. #### Tags:
see: | TCPDF::SetLineWidth(), TCPDF::SetDrawColor(), TCPDF::SetLineStyle()
since: | 1.0
access: | public
#### Parameters:
float | $x1 | Abscissa of first point.
float | $y1 | Ordinate of first point.
float | $x2 | Abscissa of second point.
float | $y2 | Ordinate of second point.
array | $style | Line style. Array like for SetLineStyle. Default value: default line style (empty array).
[ Top ] ### method LinearGradient [line 11458]
`void LinearGradient( float $x, float $y, float $w, float $h, [array $col1 = array()], [array $col2 = array()], [array $coords = array(0,0,1,0)])`
Paints a linear colour gradient. #### Tags:
author: | Andreas Würmser, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | public
#### Parameters:
float | $x | abscissa of the top left corner of the rectangle.
float | $y | ordinate of the top left corner of the rectangle.
float | $w | width of the rectangle.
float | $h | height of the rectangle.
array | $col1 | first color (RGB components).
array | $col2 | second color (RGB components).
array | $coords | array of the form (x1, y1, x2, y2) which defines the gradient vector (see linear_gradient_coords.jpg). The default value is from left to right (x1=0, y1=0, x2=1, y2=0).
[ Top ] ### method Link [line 3414]
`void Link( float $x, float $y, float $w, float $h, mixed $link, [int $spaces = 0])`
Puts a link on a rectangular area of the page. Text or image links are generally put via Cell(), Write() or Image(), but this method can be useful for instance to define a clickable area inside an image. #### Tags:
see: | TCPDF::AddLink(), TCPDF::Annotation(), TCPDF::Cell(), TCPDF::Write(), TCPDF::Image()
since: | 1.5
access: | public
#### Parameters:
float | $x | Abscissa of the upper-left corner of the rectangle
float | $y | Ordinate of the upper-left corner of the rectangle
float | $w | Width of the rectangle
float | $h | Height of the rectangle
mixed | $link | URL or identifier returned by AddLink()
int | $spaces | number of spaces on the text to link
[ Top ] ### method ListBox [line 10638]
`void ListBox( $name, $w, $h, $values, [ $prop = array()], [ $opt = array()], [ $x = ''], [ $y = ''], [ $js = false])`
#### Tags:
access: | public
#### Parameters:
| $name |
| $w |
| $h |
| $values |
| $prop |
| $opt |
| $x |
| $y |
| $js |
[ Top ] ### method Ln [line 5130]
`void Ln( [float $h = ''], [boolean $cell = false])`
Performs a line break. The current abscissa goes back to the left margin and the ordinate increases by the amount passed in parameter. #### Tags:
see: | TCPDF::Cell()
since: | 1.0
access: | public
#### Parameters:
float | $h | The height of the break. By default, the value equals the height of the last printed cell.
boolean | $cell | if true add a cMargin to the x coordinate
[ Top ] ### method MirrorH [line 8080]
`void MirrorH( [int $x = ''])`
Horizontal Mirroring. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $x | abscissa of the point. Default is current x position
[ Top ] ### method MirrorL [line 8116]
`void MirrorL( [float $angle = 0], [int $x = ''], [int $y = ''])`
Reflection against a straight line through point (x, y) with the gradient angle (angle). #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $angle | gradient angle of the straight line. Default is 0 (horizontal line).
int | $x | abscissa of the point. Default is current x position
int | $y | ordinate of the point. Default is current y position
[ Top ] ### method MirrorP [line 8103]
`void MirrorP( [int $x = ''], [int $y = ''])`
Point reflection mirroring. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $x | abscissa of the point. Default is current x position
int | $y | ordinate of the point. Default is current y position
[ Top ] ### method MirrorV [line 8091]
`void MirrorV( [int $y = ''])`
Verical Mirroring. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $y | ordinate of the point. Default is current y position
[ Top ] ### method movePage [line 15558]
`true movePage( int $frompage, int $topage)`
Move a page to a previous position. #### Tags:
return: | in case of success, false in case of error.
since: | 4.5.000 (2009-01-02)
access: | public
#### Parameters:
int | $frompage | number of the source page
int | $topage | number of the destination page (must be less than $frompage)
[ Top ] ### method MultiCell [line 3933]
`int MultiCell( float $w, float $h, string $txt, [mixed $border = 0], [string $align = 'J'], [int $fill = 0], [int $ln = 1], [float $x = ''], [float $y = ''], [boolean $reseth = true], [int $stretch = 0], [boolean $ishtml = false], [boolean $autopadding = true], [float $maxh = 0])`
This method allows printing text with line breaks. They can be automatic (as soon as the text reaches the right border of the cell) or explicit (via the \n character). As many cells as necessary are output, one below the other. Text can be aligned, centered or justified. The cell block can be framed and the background painted. #### Tags:
return: | Return the number of cells or 1 for html mode.
see: | TCPDF::SetFont(), TCPDF::SetDrawColor(), TCPDF::SetFillColor(), TCPDF::SetTextColor(), TCPDF::SetLineWidth(), TCPDF::Cell(), TCPDF::Write(), TCPDF::SetAutoPageBreak()
since: | 1.3
access: | public
usedby: | TCPDF::writeHTMLCell()
#### Parameters:
float | $w | Width of cells. If 0, they extend up to the right margin of the page.
float | $h | Cell minimum height. The cell extends automatically if needed.
string | $txt | String to print
mixed | $border | Indicates if borders must be drawn around the cell block. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
string | $align | Allows to center or align the text. Possible values are: L or empty string: left align C: center R: right align J: justification (default value when $ishtml=false)
int | $fill | Indicates if the cell background must be painted (1) or transparent (0). Default value: 0.
int | $ln | Indicates where the current position should go after the call. Possible values are: 0: to the right 1: to the beginning of the next line [DEFAULT] 2: below
float | $x | x position in user units
float | $y | y position in user units
boolean | $reseth | if true reset the last cell height (default true).
int | $stretch | stretch carachter mode: 0 = disabled 1 = horizontal scaling only if necessary 2 = forced horizontal scaling 3 = character spacing only if necessary 4 = forced character spacing
boolean | $ishtml | set to true if $txt is HTML content (default = false).
boolean | $autopadding | if true, uses internal padding and automatically adjust it to account for line width.
float | $maxh | maximum height. It should be >= $h and less then remaining space to the bottom of the page, or 0 for disable this feature. This feature works only when $ishtml=false.
[ Top ] ### method objclone [line 16037]
`cloned objclone( object $object)`
Creates a copy of a class object #### Tags:
return: | object
since: | 4.5.029 (2009-03-19)
access: | public
#### Parameters:
object | $object | class object to be cloned
[ Top ] ### method Open [line 2231]
`void Open( )`
This method begins the generation of the PDF document. It is not necessary to call it explicitly because AddPage() does it automatically. Note: no page is created by this method #### Tags:
see: | TCPDF::AddPage(), TCPDF::Close()
since: | 1.0
access: | public
[ Top ] ### method openHTMLTagHandler [line 13939]
`void openHTMLTagHandler( &$dom, int $key, [boolean $cell = false], array $dom)`
Process opening tags. #### Tags:
access: | protected
#### Parameters:
array | $dom | html dom array
int | $key | current element id
boolean | $cell | if true add the default cMargin space to each new line (default false).
| &$dom |
[ Top ] ### method Output [line 5277]
`void Output( [string $name = 'doc.pdf'], [string $dest = 'I'])`
Send the document to a given destination: string, local file or browser. In the last case, the plug-in may be used (if present) or a download ("Save as" dialog box) may be forced. The method first calls Close() if necessary to terminate the document. #### Tags:
see: | TCPDF::Close()
since: | 1.0
access: | public
#### Parameters:
string | $name | The name of the file when saved. Note that special characters are removed and blanks characters are replaced with the underscore character.
string | $dest | Destination where to send the document. It can take one of the following values: I: send the file inline to the browser (default). The plug-in is used if available. The name given by name is used when one selects the "Save as" option on the link generating the PDF. D: send to the browser and force a file download with the name given by name. F: save to a local file with the name given by name. S: return the document as a string. name is ignored.
[ Top ] ### method PageNo [line 2751]
`int PageNo( )`
Returns the current page number. #### Tags:
return: | page number
see: | TCPDF::AliasNbPages(), TCPDF::getAliasNbPages()
since: | 1.0
access: | public
[ Top ] ### method PageNoFormatted [line 11249]
`void PageNoFormatted( )`
Returns the current page number formatted as a string. #### Tags:
see: | PaneNo(), TCPDF::formatPageNumber()
since: | 4.2.005 (2008-11-06)
access: | public
[ Top ] ### method PieSector [line 11695]
`void PieSector( float $xc, float $yc, float $r, float $a, float $b, [ $style = 'FD'], [ $cw = true], [ $o = 90], string $style:, float $cw:, float $o:)`
Draw the sector of a circle. It can be used for instance to render pie charts. #### Tags:
author: | Maxime Delorme, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | public
#### Parameters:
float | $xc | abscissa of the center.
float | $yc | ordinate of the center.
float | $r | radius.
float | $a | start angle (in degrees).
float | $b | end angle (in degrees).
string | $style: | D, F, FD or DF (draw, fill, fill and draw). Default: FD.
float | $cw: | indicates whether to go clockwise (default: true).
float | $o: | origin of angles (0 for 3 o'clock, 90 for noon, 180 for 9 o'clock, 270 for 6 o'clock). Default: 90.
| $style |
| $cw |
| $o |
[ Top ] ### method pixelsToUnits [line 7782]
`float pixelsToUnits( int $px)`
Converts pixels to User's Units. #### Tags:
return: | value in user's unit
see: | TCPDF::setImageScale(), TCPDF::getImageScale()
access: | public
#### Parameters:
int | $px | pixels
[ Top ] ### method Polycurve [line 8651]
`void Polycurve( float $x0, float $y0, float $segments, [string $style = ''], [array $line_style = array()], [array $fill_color = array()])`
Draws a poly-Bezier curve. Each Bezier curve segment is a tangent to the line between the control points at either end of the curve. #### Tags:
see: | TCPDF::SetLineStyle()
since: | 3.0008 (2008-05-12)
access: | public
#### Parameters:
float | $x0 | Abscissa of start point.
float | $y0 | Ordinate of start point.
float | $segments | An array of bezier descriptions. Format: array(x1, y1, x2, y2, x3, y3).
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of curve. Array like for SetLineStyle. Default value: default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
[ Top ] ### method Polygon [line 8871]
`void Polygon( array $p, [string $style = ''], [array $line_style = array()], [array $fill_color = array()], [boolean $closed = true])`
Draws a polygon. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
array | $p | Points 0 to ($np - 1). Array with values (x0, y0, x1, y1,..., x(np-1), y(np - 1))
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of polygon. Array with keys among the following: all: Line style of all lines. Array like for SetLineStyle. 0 to ($np - 1): Line style of each line. Array like for SetLineStyle. If a key is not present or is null, not draws the line. Default value is default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
boolean | $closed | if true the polygon is closes, otherwise will remain open
[ Top ] ### method PolyLine [line 8845]
`void PolyLine( array $p, [string $style = ''], [array $line_style = array()], [array $fill_color = array()], boolean $closed)`
Draws a polygonal line #### Tags:
since: | 4.8.003 (2009-09-15)
access: | public
#### Parameters:
array | $p | Points 0 to ($np - 1). Array with values (x0, y0, x1, y1,..., x(np-1), y(np - 1))
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of polygon. Array with keys among the following: all: Line style of all lines. Array like for SetLineStyle. 0 to ($np - 1): Line style of each line. Array like for SetLineStyle. If a key is not present or is null, not draws the line. Default value is default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
boolean | $closed | if true the polygon is closes, otherwise will remain open
[ Top ] ### method putHtmlListBullet [line 15107]
`void putHtmlListBullet( int $listdepth, [string $listtype = ''], [float $size = 10])`
Output an HTML list bullet or ordered item symbol #### Tags:
since: | 4.4.004 (2008-12-10)
access: | protected
#### Parameters:
int | $listdepth | list nesting level
string | $listtype | type of list
float | $size | current font size
[ Top ] ### method RadialGradient [line 11476]
`void RadialGradient( float $x, float $y, float $w, float $h, [array $col1 = array()], [array $col2 = array()], [array $coords = array(0.5,0.5,0.5,0.5,1)])`
Paints a radial colour gradient. #### Tags:
author: | Andreas Würmser, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | public
#### Parameters:
float | $x | abscissa of the top left corner of the rectangle.
float | $y | ordinate of the top left corner of the rectangle.
float | $w | width of the rectangle.
float | $h | height of the rectangle.
array | $col1 | first color (RGB components).
array | $col2 | second color (RGB components).
array | $coords | array of the form (fx, fy, cx, cy, r) where (fx, fy) is the starting point of the gradient with color1, (cx, cy) is the center of the circle with color2, and r is the radius of the circle (see radial_gradient_coords.jpg). (fx, fy) should be inside the circle, otherwise some areas will not be defined.
[ Top ] ### method RadioButton [line 10550]
`void RadioButton( $name, $w, [ $prop = array()], [ $opt = array()], [ $onvalue = 'On'], [ $checked = false], [ $x = ''], [ $y = ''], [ $js = false])`
#### Tags:
access: | public
#### Parameters:
| $name |
| $w |
| $prop |
| $opt |
| $onvalue |
| $checked |
| $x |
| $y |
| $js |
[ Top ] ### method readDiskCache [line 15353]
`mixed readDiskCache( $filename, string $file)`
Read data from a temporary file on filesystem. #### Tags:
return: | retrieved data
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
string | $file | file name
| $filename |
[ Top ] ### method Rect [line 8496]
`void Rect( float $x, float $y, float $w, float $h, [string $style = ''], [array $border_style = array()], [array $fill_color = array()])`
Draws a rectangle. #### Tags:
see: | TCPDF::SetLineStyle()
since: | 1.0
access: | public
#### Parameters:
float | $x | Abscissa of upper-left corner (or upper-right corner for RTL language).
float | $y | Ordinate of upper-left corner (or upper-right corner for RTL language).
float | $w | Width.
float | $h | Height.
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $border_style | Border style of rectangle. Array like for SetLineStyle. Default value: default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
[ Top ] ### method RegularPolygon [line 8996]
`void RegularPolygon( float $x0, float $y0, $r, integer $ns, [float $angle = 0], [boolean $draw_circle = false], [string $style = ''], [array $line_style = array()], [array $fill_color = array()], [string $circle_style = ''], [array $circle_outLine_style = array()], [array $circle_fill_color = array()], float $r:)`
Draws a regular polygon. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
float | $x0 | Abscissa of center point.
float | $y0 | Ordinate of center point.
float | $r: | Radius of inscribed circle.
integer | $ns | Number of sides.
float | $angle | Angle oriented (anti-clockwise). Default value: 0.
boolean | $draw_circle | Draw inscribed circle or not. Default value: false.
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of polygon sides. Array with keys among the following: all: Line style of all sides. Array like for SetLineStyle. 0 to ($ns - 1): Line style of each side. Array like for SetLineStyle. If a key is not present or is null, not draws the side. Default value is default line style (empty array).
array | $fill_color | Fill color. Format: array(red, green, blue). Default value: default color (empty array).
string | $circle_style | Style of rendering of inscribed circle (if draws). Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $circle_outLine_style | Line style of inscribed circle (if draws). Array like for SetLineStyle. Default value: default line style (empty array).
array | $circle_fill_color | Fill color of inscribed circle (if draws). Format: array(red, green, blue). Default value: default color (empty array).
| $r |
[ Top ] ### method removeSHY [line 3660]
`string removeSHY( [string $txt = ''])`
Removes SHY characters from text. #### Tags:
return: | without SHY characters.
since: | (4.5.019) 2009-02-28
access: | public
#### Parameters:
string | $txt | input string
[ Top ] ### method rfread [line 5043]
`Returns rfread( resource $handle, int $length)`
Binary-safe and URL-safe file read. Reads up to length bytes from the file pointer referenced by handle. Reading stops as soon as one of the following conditions is met: length bytes have been read; EOF (end of file) is reached. #### Tags:
return: | the read string or FALSE in case of error.
author: | Nicola Asuni
since: | 4.5.027 (2009-03-16)
access: | protected
#### Parameters:
resource | $handle |
int | $length |
[ Top ] ### method rollbackTransaction [line 16008]
`TCPDF rollbackTransaction( [boolean $self = false])`
This method allows to undo the latest transaction by returning the latest saved TCPDF object with startTransaction(). #### Tags:
return: | object.
since: | 4.5.029 (2009-03-19)
access: | public
#### Parameters:
boolean | $self | if true restores current class object to previous state without the need of reassignment via the returned value.
[ Top ] ### method Rotate [line 8175]
`void Rotate( float $angle, [int $x = ''], [int $y = ''])`
Rotate object. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $angle | angle in degrees for counter-clockwise rotation
int | $x | abscissa of the rotation center. Default is current x position
int | $y | ordinate of the rotation center. Default is current y position
[ Top ] ### method RoundedRect [line 9100]
`void RoundedRect( float $x, float $y, float $w, float $h, float $r, [string $round_corner = '1111'], [string $style = ''], [array $border_style = array()], [array $fill_color = array()])`
Draws a rounded rectangle. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
float | $x | Abscissa of upper-left corner.
float | $y | Ordinate of upper-left corner.
float | $w | Width.
float | $h | Height.
float | $r | Radius of the rounded corners.
string | $round_corner | Draws rounded corner or not. String with a 0 (not rounded i-corner) or 1 (rounded i-corner) in i-position. Positions are, in order and begin to 0: top left, top right, bottom right and bottom left. Default value: all rounded corner ("1111").
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $border_style | Border style of rectangle. Array like for SetLineStyle. Default value: default line style (empty array).
array | $fill_color | Fill color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K). Default value: default color (empty array).
[ Top ] ### method Scale [line 8045]
`void Scale( float $s_x, float $s_y, [int $x = ''], [int $y = ''])`
Vertical and horizontal non-proportional Scaling. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $s_x | scaling factor for width as percent. 0 is not allowed.
float | $s_y | scaling factor for height as percent. 0 is not allowed.
int | $x | abscissa of the scaling center. Default is current x position
int | $y | ordinate of the scaling center. Default is current y position
[ Top ] ### method ScaleX [line 8005]
`void ScaleX( float $s_x, [int $x = ''], [int $y = ''])`
Horizontal Scaling. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $s_x | scaling factor for width as percent. 0 is not allowed.
int | $x | abscissa of the scaling center. Default is current x position
int | $y | ordinate of the scaling center. Default is current y position
[ Top ] ### method ScaleXY [line 8031]
`void ScaleXY( float $s, [int $x = ''], [int $y = ''])`
Vertical and horizontal proportional Scaling. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $s | scaling factor for width and height as percent. 0 is not allowed.
int | $x | abscissa of the scaling center. Default is current x position
int | $y | ordinate of the scaling center. Default is current y position
[ Top ] ### method ScaleY [line 8018]
`void ScaleY( float $s_y, [int $x = ''], [int $y = ''])`
Vertical Scaling. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $s_y | scaling factor for height as percent. 0 is not allowed.
int | $x | abscissa of the scaling center. Default is current x position
int | $y | ordinate of the scaling center. Default is current y position
[ Top ] ### method setAlpha [line 11358]
`void setAlpha( $alpha, [ $bm = 'Normal'])`
#### Tags:
access: | public
#### Parameters:
| $alpha |
| $bm |
[ Top ] ### method SetAuthor [line 2180]
`void SetAuthor( string $author)`
Defines the author of the document. #### Tags:
see: | TCPDF::SetCreator(), TCPDF::SetKeywords(), TCPDF::SetSubject(), TCPDF::SetTitle()
since: | 1.2
access: | public
#### Parameters:
string | $author | The name of the author.
[ Top ] ### method SetAutoPageBreak [line 2047]
`void SetAutoPageBreak( boolean $auto, [float $margin = 0])`
Enables or disables the automatic page breaking mode. When enabling, the second parameter is the distance from the bottom of the page that defines the triggering limit. By default, the mode is on and the margin is 2 cm. #### Tags:
see: | TCPDF::Cell(), TCPDF::MultiCell(), TCPDF::AcceptPageBreak()
since: | 1.0
access: | public
#### Parameters:
boolean | $auto | Boolean indicating if mode should be on or off.
float | $margin | Distance from the bottom of the page.
[ Top ] ### method setBarcode [line 12033]
`void setBarcode( [string $bc = ''])`
Set document barcode. #### Tags:
access: | public
#### Parameters:
string | $bc | barcode
[ Top ] ### method SetBooklet [line 14882]
`void SetBooklet( [boolean $booklet = true], [float $inner = -1], [float $outer = -1])`
Set the booklet mode for double-sided pages. #### Tags:
since: | 4.2.000 (2008-10-29)
access: | public
#### Parameters:
boolean | $booklet | true set the booklet mode on, fals eotherwise.
float | $inner | Inner page margin.
float | $outer | Outer page margin.
[ Top ] ### method setBuffer [line 15363]
`void setBuffer( string $data)`
Set buffer content (always append data). #### Tags:
since: | 4.5.000 (2009-01-02)
access: | protected
#### Parameters:
string | $data | data
[ Top ] ### method setCellHeightRatio [line 11392]
`void setCellHeightRatio( $h)`
#### Tags:
access: | public
#### Parameters:
| $h |
[ Top ] ### method SetCellPadding [line 2035]
`void SetCellPadding( float $pad)`
Set the internal Cell padding. #### Tags:
see: | TCPDF::Cell(), TCPDF::SetLeftMargin(), TCPDF::SetTopMargin(), TCPDF::SetAutoPageBreak(), TCPDF::SetMargins()
since: | 2.1.000 (2008-01-09)
access: | public
#### Parameters:
float | $pad | internal padding.
[ Top ] ### method SetCompression [line 2140]
`void SetCompression( boolean $compress)`
Activates or deactivates page compression. When activated, the internal representation of each page is compressed, which leads to a compression ratio of about 2 for the resulting document. Compression is on by default. Note: the Zlib extension is required for this feature. If not present, compression will be turned off. #### Tags:
since: | 1.4
access: | public
#### Parameters:
boolean | $compress | Boolean indicating if compression must be enabled.
[ Top ] ### method setContentMark [line 2444]
`void setContentMark( [int $page = 0])`
Set start-writing mark on selected page. #### Tags:
since: | 4.6.021 (2009-07-20)
access: | protected
#### Parameters:
int | $page | page number (default is the current page)
[ Top ] ### method SetCreator [line 2204]
`void SetCreator( string $creator)`
Defines the creator of the document. This is typically the name of the application that generates the PDF. #### Tags:
see: | TCPDF::SetAuthor(), TCPDF::SetKeywords(), TCPDF::SetSubject(), TCPDF::SetTitle()
since: | 1.2
access: | public
#### Parameters:
string | $creator | The name of the creator.
[ Top ] ### method SetDefaultMonospacedFont [line 3364]
`void SetDefaultMonospacedFont( string $font)`
Defines the default monospaced font. #### Tags:
since: | 4.5.025
access: | public
#### Parameters:
string | $font | Font name.
[ Top ] ### method setDefaultTableColumns [line 11382]
`void setDefaultTableColumns( [ $cols = 4])`
#### Tags:
access: | public
#### Parameters:
| $cols |
[ Top ] ### method SetDisplayMode [line 2062]
`void SetDisplayMode( mixed $zoom, [string $layout = 'SinglePage'], [string $mode = 'UseNone'])`
Defines the way the document is to be displayed by the viewer. #### Tags:
since: | 1.2
access: | public
#### Parameters:
mixed | $zoom | The zoom to use. It can be one of the following string values or a number indicating the zooming factor to use. fullpage: displays the entire page on screen fullwidth: uses maximum width of window real: uses real size (equivalent to 100% zoom) default: uses viewer default mode
string | $layout | The page layout. Possible values are: SinglePage Display one page at a time OneColumn Display the pages in one column TwoColumnLeft Display the pages in two columns, with odd-numbered pages on the left TwoColumnRight Display the pages in two columns, with odd-numbered pages on the right TwoPageLeft (PDF 1.5) Display the pages two at a time, with odd-numbered pages on the left TwoPageRight (PDF 1.5) Display the pages two at a time, with odd-numbered pages on the right
string | $mode | A name object specifying how the document should be displayed when opened: UseNone Neither document outline nor thumbnail images visible UseOutlines Document outline visible UseThumbs Thumbnail images visible FullScreen Full-screen mode, with no menu bar, window controls, or any other window visible UseOC (PDF 1.5) Optional content group panel visible UseAttachments (PDF 1.6) Attachments panel visible
[ Top ] ### method SetDrawColor [line 2806]
`void SetDrawColor( [int $col1 = 0], [int $col2 = -1], [int $col3 = -1], [int $col4 = -1])`
Defines the color used for all drawing operations (lines, rectangles and cell borders). It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetDrawColorArray(), TCPDF::SetFillColor(), TCPDF::SetTextColor(), TCPDF::Line(), TCPDF::Rect(), TCPDF::Cell(), TCPDF::MultiCell()
since: | 1.3
access: | public
#### Parameters:
int | $col1 | Gray level for single color, or Red color for RGB, or Cyan color for CMYK. Value between 0 and 255
int | $col2 | Green color for RGB, or Magenta color for CMYK. Value between 0 and 255
int | $col3 | Blue color for RGB, or Yellow color for CMYK. Value between 0 and 255
int | $col4 | Key (Black) color for CMYK. Value between 0 and 255
[ Top ] ### method SetDrawColorArray [line 2783]
`void SetDrawColorArray( array $color)`
Defines the color used for all drawing operations (lines, rectangles and cell borders). It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetDrawColor()
since: | 3.1.000 (2008-06-11)
access: | public
#### Parameters:
array | $color | array of colors
[ Top ] ### method SetDrawSpotColor [line 2844]
`void SetDrawSpotColor( string $name, [int $tint = 100])`
Defines the spot color used for all drawing operations (lines, rectangles and cell borders). #### Tags:
see: | TCPDF::AddSpotColor(), TCPDF::SetFillSpotColor(), TCPDF::SetTextSpotColor()
since: | 4.0.024 (2008-09-12)
access: | public
#### Parameters:
string | $name | name of the spot color
int | $tint | the intensity of the color (from 0 to 100 ; 100 = full intensity by default).
[ Top ] ### method setExtGState [line 11327]
`void setExtGState( $gs)`
#### Tags:
access: | protected
#### Parameters:
| $gs |
[ Top ] ### method SetFillColor [line 2886]
`void SetFillColor( [int $col1 = 0], [int $col2 = -1], [int $col3 = -1], [int $col4 = -1])`
Defines the color used for all filling operations (filled rectangles and cell backgrounds). It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetFillColorArray(), TCPDF::SetDrawColor(), TCPDF::SetTextColor(), TCPDF::Rect(), TCPDF::Cell(), TCPDF::MultiCell()
since: | 1.3
access: | public
#### Parameters:
int | $col1 | Gray level for single color, or Red color for RGB, or Cyan color for CMYK. Value between 0 and 255
int | $col2 | Green color for RGB, or Magenta color for CMYK. Value between 0 and 255
int | $col3 | Blue color for RGB, or Yellow color for CMYK. Value between 0 and 255
int | $col4 | Key (Black) color for CMYK. Value between 0 and 255
[ Top ] ### method SetFillColorArray [line 2863]
`void SetFillColorArray( array $color)`
Defines the color used for all filling operations (filled rectangles and cell backgrounds). It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetFillColor()
since: | 3.1.000 (2008-6-11)
access: | public
#### Parameters:
array | $color | array of colors
[ Top ] ### method SetFillSpotColor [line 2928]
`void SetFillSpotColor( string $name, [int $tint = 100])`
Defines the spot color used for all filling operations (filled rectangles and cell backgrounds). #### Tags:
see: | TCPDF::AddSpotColor(), TCPDF::SetDrawSpotColor(), TCPDF::SetTextSpotColor()
since: | 4.0.024 (2008-09-12)
access: | public
#### Parameters:
string | $name | name of the spot color
int | $tint | the intensity of the color (from 0 to 100 ; 100 = full intensity by default).
[ Top ] ### method SetFont [line 3319]
`void SetFont( string $family, [string $style = ''], [float $size = 0], [string $fontfile = ''])`
Sets the font used to print character strings. The font can be either a standard one or a font added via the AddFont() method. Standard fonts use Windows encoding cp1252 (Western Europe). The method can be called before the first page is created and the font is retained from page to page. If you just wish to change the current font size, it is simpler to call SetFontSize(). Note: for the standard fonts, the font metric files must be accessible. There are three possibilities for this: They are in the current directory (the one where the running script lies) They are in one of the directories defined by the include_path parameter They are in the directory defined by the K_PATH_FONTS constant #### Tags:
see: | TCPDF::AddFont(), TCPDF::SetFontSize()
since: | 1.0
access: | public
#### Parameters:
string | $family | Family font. It can be either a name defined by AddFont() or one of the standard Type1 families (case insensitive): times (Times-Roman) timesb (Times-Bold) timesi (Times-Italic) timesbi (Times-BoldItalic) helvetica (Helvetica) helveticab (Helvetica-Bold) helveticai (Helvetica-Oblique) helveticabi (Helvetica-BoldOblique) courier (Courier) courierb (Courier-Bold) courieri (Courier-Oblique) courierbi (Courier-BoldOblique) symbol (Symbol) zapfdingbats (ZapfDingbats) It is also possible to pass an empty string. In that case, the current family is retained.
string | $style | Font style. Possible values are (case insensitive): empty string: regular B: bold I: italic U: underline D: line trough or any combination. The default value is regular. Bold and italic styles do not apply to Symbol and ZapfDingbats basic fonts or other fonts when not defined.
float | $size | Font size in points. The default value is the current size. If no size has been specified since the beginning of the document, the value taken is 12
string | $fontfile | The font definition file. By default, the name is built from the family and style, in lower case with no spaces.
[ Top ] ### method setFontBuffer [line 15499]
`void setFontBuffer( string $font, array $data)`
Set font buffer content. #### Tags:
since: | 4.5.000 (2009-01-02)
access: | protected
#### Parameters:
string | $font | font key
array | $data | font data
[ Top ] ### method SetFontSize [line 3339]
`void SetFontSize( float $size)`
Defines the size of the current font. #### Tags:
see: | TCPDF::SetFont()
since: | 1.0
access: | public
#### Parameters:
float | $size | The size (in points)
[ Top ] ### method setFontSubBuffer [line 15521]
`void setFontSubBuffer( string $font, string $key, array $data)`
Set font buffer content. #### Tags:
since: | 4.5.000 (2009-01-02)
access: | protected
#### Parameters:
string | $font | font key
string | $key | font sub-key
array | $data | font data
[ Top ] ### method setFooter [line 2674]
`void setFooter( )`
This method is used to render the page footer. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | protected
[ Top ] ### method setFooterFont [line 7641]
`void setFooterFont( array $font)`
Set footer font. #### Tags:
since: | 1.1
access: | public
#### Parameters:
array | $font | font
[ Top ] ### method setFooterMargin [line 2512]
`void setFooterMargin( [int $fm = 10])`
Set footer margin. (minimum distance between footer and bottom page margin) #### Tags:
access: | public
#### Parameters:
int | $fm | distance in user units
[ Top ] ### method setFormDefaultProp [line 10430]
`void setFormDefaultProp( [ $prop = array()])`
#### Tags:
access: | public
#### Parameters:
| $prop |
[ Top ] ### method setGraphicVars [line 15280]
`void setGraphicVars( $gvars $gvars)`
Set graphic variables. #### Tags:
since: | 4.2.010 (2008-11-14)
access: | protected
#### Parameters:
$gvars | $gvars | array graphic variables
[ Top ] ### method setHeader [line 2643]
`void setHeader( )`
This method is used to render the page header. #### Tags:
since: | 4.0.012 (2008-07-24)
access: | protected
[ Top ] ### method setHeaderData [line 2463]
`void setHeaderData( [string $ln = ''], [string $lw = 0], [string $ht = ''], [string $hs = ''])`
Set header data. #### Tags:
access: | public
#### Parameters:
string | $ln | header image logo
string | $lw | header image logo width in mm
string | $ht | string to print as title on document header
string | $hs | string to print on document header
[ Top ] ### method setHeaderFont [line 7621]
`void setHeaderFont( array $font)`
Set header font. #### Tags:
since: | 1.1
access: | public
#### Parameters:
array | $font | font
[ Top ] ### method setHeaderMargin [line 2492]
`void setHeaderMargin( [int $hm = 10])`
Set header margin. (minimum distance between header and top page margin) #### Tags:
access: | public
#### Parameters:
int | $hm | distance in user units
[ Top ] ### method setHtmlLinksStyle [line 14953]
`void setHtmlLinksStyle( [array $color = array(0,0,255)], [string $fontstyle = 'U'])`
Set the color and font style for HTML links. #### Tags:
since: | 4.4.003 (2008-12-09)
access: | public
#### Parameters:
array | $color | RGB array of colors
string | $fontstyle | additional font styles to add
[ Top ] ### method setHtmlVSpace [line 14922]
`void setHtmlVSpace( array $tagvs)`
Set the vertical spaces for HTML tags. The array must have the following structure (example): $tagvs = array('h1' => array(0 => array('h' => '', 'n' => 2), 1 => array('h' => 1.3, 'n' => 1))); The first array level contains the tag names, the second level contains 0 for opening tags or 1 for closing tags, the third level contains the vertical space unit (h) and the number spaces to add (n). If the h parameter is not specified, default values are used. #### Tags:
since: | 4.2.001 (2008-10-30)
access: | public
#### Parameters:
array | $tagvs | array of tags and relative vertical spaces.
[ Top ] ### method setImageBuffer [line 15440]
`void setImageBuffer( string $image, array $data)`
Set image buffer content. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
string | $image | image key
array | $data | image data
[ Top ] ### method setImageScale [line 1875]
`void setImageScale( float $scale)`
Set the adjusting factor to convert pixels to user units. #### Tags:
author: | Nicola Asuni
since: | 1.5.2
access: | public
#### Parameters:
float | $scale | adjusting factor to convert pixels to user units.
[ Top ] ### method setImageSubBuffer [line 15463]
`void setImageSubBuffer( string $image, string $key, array $data)`
Set image buffer content. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
string | $image | image key
string | $key | image sub-key
array | $data | image data
[ Top ] ### method setJPEGQuality [line 11369]
`void setJPEGQuality( $quality)`
#### Tags:
access: | public
#### Parameters:
| $quality |
[ Top ] ### method SetKeywords [line 2192]
`void SetKeywords( string $keywords)`
Associates keywords with the document, generally in the form 'keyword1 keyword2 ...'. #### Tags:
see: | TCPDF::SetAuthor(), TCPDF::SetCreator(), TCPDF::SetSubject(), TCPDF::SetTitle()
since: | 1.2
access: | public
#### Parameters:
string | $keywords | The list of keywords.
[ Top ] ### method setLanguageArray [line 7661]
`void setLanguageArray( array $language)`
Set language array. #### Tags:
since: | 1.1
access: | public
#### Parameters:
array | $language |
[ Top ] ### method setLastH [line 1854]
`void setLastH( float $h)`
Set the last cell height. #### Tags:
author: | Nicola Asuni
since: | 1.53.0.TC034
access: | public
#### Parameters:
float | $h | cell height.
[ Top ] ### method SetLeftMargin [line 1991]
`void SetLeftMargin( float $margin)`
Defines the left margin. The method can be called before creating the first page. If the current abscissa gets out of page, it is brought back to the margin. #### Tags:
see: | TCPDF::SetTopMargin(), TCPDF::SetRightMargin(), TCPDF::SetAutoPageBreak(), TCPDF::SetMargins()
since: | 1.4
access: | public
#### Parameters:
float | $margin | The margin.
[ Top ] ### method SetLineStyle [line 8333]
`void SetLineStyle( array $style)`
Set line style. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
array | $style | Line style. Array with keys among the following: width (float): Width of the line in user units. cap (string): Type of cap to put on the line. Possible values are: butt, round, square. The difference between "square" and "butt" is that "square" projects a flat end past the end of the line. join (string): Type of join. Possible values are: miter, round, bevel. dash (mixed): Dash pattern. Is 0 (without dash) or string with series of length values, which are the lengths of the on and off dashes. For example: "2" represents 2 on, 2 off, 2 on, 2 off, ...; "2,1" is 2 on, 1 off, 2 on, 1 off, ... phase (integer): Modifier on the dash pattern which is used to shift the point at which the pattern starts. color (array): Draw color. Format: array(GREY) or array(R,G,B) or array(C,M,Y,K).
[ Top ] ### method SetLineWidth [line 8292]
`void SetLineWidth( float $width)`
Defines the line width. By default, the value equals 0.2 mm. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::Line(), TCPDF::Rect(), TCPDF::Cell(), TCPDF::MultiCell()
since: | 1.0
access: | public
#### Parameters:
float | $width | The width.
[ Top ] ### method SetLink [line 3391]
`void SetLink( int $link, [float $y = 0], [int $page = -1])`
Defines the page and position a link points to. #### Tags:
see: | TCPDF::AddLink()
since: | 1.5
access: | public
#### Parameters:
int | $link | The link identifier returned by AddLink()
float | $y | Ordinate of target position; -1 indicates the current position. The default value is 0 (top of page)
int | $page | Number of target page; -1 indicates the current page. This is the default value
[ Top ] ### method setListIndentWidth [line 14932]
`void setListIndentWidth( float $width)`
Set custom width for list indentation. #### Tags:
since: | 4.2.007 (2008-11-12)
access: | public
#### Parameters:
float | $width | width of the indentation. Use negative value to disable it.
[ Top ] ### method setLIsymbol [line 14842]
`void setLIsymbol( [string $symbol = '!'])`
Set the default bullet to be used as LI bullet symbol #### Tags:
since: | 4.0.028 (2008-09-26)
access: | public
#### Parameters:
string | $symbol | character or string to be used (legal values are: '' = automatic, '!' = auto bullet, '#' = auto numbering, 'disc', 'disc', 'circle', 'square', '1', 'decimal', 'decimal-leading-zero', 'i', 'lower-roman', 'I', 'upper-roman', 'a', 'lower-alpha', 'lower-latin', 'A', 'upper-alpha', 'upper-latin', 'lower-greek')
[ Top ] ### method SetMargins [line 1974]
`void SetMargins( float $left, float $top, [float $right = -1])`
Defines the left, top and right margins. By default, they equal 1 cm. Call this method to change them. #### Tags:
see: | TCPDF::SetLeftMargin(), TCPDF::SetTopMargin(), TCPDF::SetRightMargin(), TCPDF::SetAutoPageBreak()
since: | 1.0
access: | public
#### Parameters:
float | $left | Left margin.
float | $top | Top margin.
float | $right | Right margin. Default value is the left one.
[ Top ] ### method setOpenCell [line 14942]
`void setOpenCell( boolean $isopen)`
Set the top/bottom cell sides to be open or closed when the cell cross the page. #### Tags:
since: | 4.2.010 (2008-11-14)
access: | public
#### Parameters:
boolean | $isopen | if true keeps the top/bottom border open for the cell sides that cross the page.
[ Top ] ### method setPage [line 2267]
`void setPage( int $pnum, [boolean $resetmargins = false])`
Move pointer at the specified document page and update page dimensions. #### Tags:
see: | TCPDF::getPage(), lastpage(), TCPDF::getNumPages()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $pnum | page number
boolean | $resetmargins | if true reset left, right, top margins and Y position.
[ Top ] ### method setPageBuffer [line 15397]
`void setPageBuffer( int $page, string $data, [boolean $append = false])`
Set page buffer content. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
int | $page | page number
string | $data | page data
boolean | $append | if true append data, false replace.
[ Top ] ### method setPageFormat [line 1682]
`void setPageFormat( mixed $format, [string $orientation = 'P'])`
Set the page format #### Tags:
since: | 3.0.015 (2008-06-06)
access: | public
#### Parameters:
mixed | $format | The format used for pages. It can be either one of the following values (case insensitive) or a custom format in the form of a two-element array containing the width and the height (expressed in the unit given by unit). 4A0 2A0 A0 A1 A2 A3 A4 (default) A5 A6 A7 A8 A9 A10 B0 B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 C10 RA0 RA1 RA2 RA3 RA4 SRA0 SRA1 SRA2 SRA3 SRA4 LETTER LEGAL EXECUTIVE FOLIO
string | $orientation | page orientation. Possible values are (case insensitive): P or PORTRAIT (default) L or LANDSCAPE
[ Top ] ### method setPageMark [line 2433]
`void setPageMark( )`
Set start-writing mark on current page for multicell borders and fills. This function must be called after calling Image() function for a background image. Background images must be always inserted before calling Multicell() or WriteHTMLCell() or WriteHTML() functions. #### Tags:
since: | 4.0.016 (2008-07-30)
access: | public
[ Top ] ### method setPageOrientation [line 1755]
`void setPageOrientation( string $orientation, [boolean $autopagebreak = ''], [float $bottommargin = ''])`
Set page orientation. #### Tags:
since: | 3.0.015 (2008-06-06)
access: | public
#### Parameters:
string | $orientation | page orientation. Possible values are (case insensitive): P or PORTRAIT (default) L or LANDSCAPE
boolean | $autopagebreak | Boolean indicating if auto-page-break mode should be on or off.
float | $bottommargin | bottom margin of the page.
[ Top ] ### method setPageUnit [line 1640]
`void setPageUnit( string $unit)`
Set the units of measure for the document. #### Tags:
since: | 3.0.015 (2008-06-06)
access: | public
#### Parameters:
string | $unit | User measure unit. Possible values are: pt: point mm: millimeter (default) cm: centimeter in: inch A point equals 1/72 of inch, that is to say about 0.35 mm (an inch being 2.54 cm). This is a very common unit in typography; font sizes are expressed in that unit.
[ Top ] ### method setPDFVersion [line 11411]
`void setPDFVersion( [ $version = '1.7'])`
#### Tags:
access: | public
#### Parameters:
| $version |
[ Top ] ### method setPrintFooter [line 2539]
`void setPrintFooter( [ $val = true], boolean $value)`
Set a flag to print page footer. #### Tags:
access: | public
#### Parameters:
boolean | $value | set to true to print the page footer (default), false otherwise.
| $val |
[ Top ] ### method setPrintHeader [line 2530]
`void setPrintHeader( [boolean $val = true])`
Set a flag to print page header. #### Tags:
access: | public
#### Parameters:
boolean | $val | set to true to print the page header (default), false otherwise.
[ Top ] ### method SetProtection [line 7945]
`void SetProtection( [Array $permissions = array()], [String $user_pass = ''], [String $owner_pass = null])`
Set document protection The permission array is composed of values taken from the following ones: copy: copy text and images to the clipboard print: print the document modify: modify it (except for annotations and forms) annot-forms: add annotations and forms Remark: the protection against modification is for people who have the full Acrobat product. If you don't set any password, the document will open as usual. If you set a user password, the PDF viewer will ask for it before displaying the document. The master password, if different from the user one, can be used to get full access. Note: protecting a document requires to encrypt it, which increases the processing time a lot. This can cause a PHP time-out in some cases, especially if the document contains images or fonts. #### Tags:
author: | Klemen Vodopivec
since: | 2.0.000 (2008-01-02)
access: | public
#### Parameters:
Array | $permissions | the set of permissions. Empty by default (only viewing is allowed). (print, modify, copy, annot-forms)
String | $user_pass | user password. Empty by default.
String | $owner_pass | owner password. If not specified, a random value is used.
[ Top ] ### method SetRightMargin [line 2021]
`void SetRightMargin( float $margin)`
Defines the right margin. The method can be called before creating the first page. #### Tags:
see: | TCPDF::SetLeftMargin(), TCPDF::SetTopMargin(), TCPDF::SetAutoPageBreak(), TCPDF::SetMargins()
since: | 1.5
access: | public
#### Parameters:
float | $margin | The margin.
[ Top ] ### method setRTL [line 1811]
`void setRTL( Boolean $enable, [Boolean $resetx = true])`
Enable or disable Right-To-Left language mode #### Tags:
since: | 2.0.000 (2008-01-03)
access: | public
#### Parameters:
Boolean | $enable | if true enable Right-To-Left language mode.
Boolean | $resetx | if true reset the X position on direction change.
[ Top ] ### method setSignature [line 11080]
`void setSignature( [ $signing_cert = ''], [ $private_key = ''], [ $private_key_password = ''], [ $extracerts = ''], [ $cert_type = 2], [ $info = array()])`
#### Tags:
access: | public
#### Parameters:
| $signing_cert |
| $private_key |
| $private_key_password |
| $extracerts |
| $cert_type |
| $info |
[ Top ] ### method setSpacesRE [line 1796]
`void setSpacesRE( [string $re = '/[\s]/'])`
Set regular expression to detect withespaces or word separators. #### Tags:
since: | 4.6.016 (2009-06-15)
access: | public
#### Parameters:
string | $re | regular expression (leave empty for default).
[ Top ] ### method SetSubject [line 2168]
`void SetSubject( string $subject)`
Defines the subject of the document. #### Tags:
see: | TCPDF::SetAuthor(), TCPDF::SetCreator(), TCPDF::SetKeywords(), TCPDF::SetTitle()
since: | 1.2
access: | public
#### Parameters:
string | $subject | The subject.
[ Top ] ### method setTableHeader [line 2716]
`void setTableHeader( )`
This method is used to render the table header on new page (if any). #### Tags:
since: | 4.5.030 (2009-03-25)
access: | protected
[ Top ] ### method setTempRTL [line 1837]
`void setTempRTL( mixed $mode)`
Force temporary RTL language direction #### Tags:
since: | 2.1.000 (2008-01-09)
access: | public
#### Parameters:
mixed | $mode | can be false, 'L' for LTR or 'R' for RTL
[ Top ] ### method SetTextColor [line 2970]
`void SetTextColor( [int $col1 = 0], [int $col2 = -1], [int $col3 = -1], [int $col4 = -1])`
Defines the color used for text. It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetTextColorArray(), TCPDF::SetDrawColor(), TCPDF::SetFillColor(), TCPDF::Text(), TCPDF::Cell(), TCPDF::MultiCell()
since: | 1.3
access: | public
#### Parameters:
int | $col1 | Gray level for single color, or Red color for RGB, or Cyan color for CMYK. Value between 0 and 255
int | $col2 | Green color for RGB, or Magenta color for CMYK. Value between 0 and 255
int | $col3 | Blue color for RGB, or Yellow color for CMYK. Value between 0 and 255
int | $col4 | Key (Black) color for CMYK. Value between 0 and 255
[ Top ] ### method SetTextColorArray [line 2947]
`void SetTextColorArray( array $color)`
Defines the color used for text. It can be expressed in RGB components or gray scale. The method can be called before the first page is created and the value is retained from page to page. #### Tags:
see: | TCPDF::SetFillColor()
since: | 3.1.000 (2008-6-11)
access: | public
#### Parameters:
array | $color | array of colors
[ Top ] ### method SetTextSpotColor [line 3009]
`void SetTextSpotColor( string $name, [int $tint = 100])`
Defines the spot color used for text. #### Tags:
see: | TCPDF::AddSpotColor(), TCPDF::SetDrawSpotColor(), TCPDF::SetFillSpotColor()
since: | 4.0.024 (2008-09-12)
access: | public
#### Parameters:
string | $name | name of the spot color
int | $tint | the intensity of the color (from 0 to 100 ; 100 = full intensity by default).
[ Top ] ### method SetTitle [line 2156]
`void SetTitle( string $title)`
Defines the title of the document. #### Tags:
see: | TCPDF::SetAuthor(), TCPDF::SetCreator(), TCPDF::SetKeywords(), TCPDF::SetSubject()
since: | 1.2
access: | public
#### Parameters:
string | $title | The title.
[ Top ] ### method SetTopMargin [line 2006]
`void SetTopMargin( float $margin)`
Defines the top margin. The method can be called before creating the first page. #### Tags:
see: | TCPDF::SetLeftMargin(), TCPDF::SetRightMargin(), TCPDF::SetAutoPageBreak(), TCPDF::SetMargins()
since: | 1.5
access: | public
#### Parameters:
float | $margin | The margin.
[ Top ] ### method setUserRights [line 11050]
`void setUserRights( [ $enable = true], [ $document = '/FullSave'], [ $annots = '/Create/Delete/Modify/Copy/Import/Export'], [ $form = '/Add/Delete/FillIn/Import/Export/SubmitStandalone/SpawnTemplate'], [ $signature = '/Modify'])`
#### Tags:
access: | public
#### Parameters:
| $enable |
| $document |
| $annots |
| $form |
| $signature |
[ Top ] ### method setViewerPreferences [line 11441]
`void setViewerPreferences( $preferences)`
#### Tags:
access: | public
#### Parameters:
| $preferences |
[ Top ] ### method setVisibility [line 11279]
`void setVisibility( $v)`
#### Tags:
access: | public
#### Parameters:
| $v |
[ Top ] ### method SetX [line 5198]
`void SetX( float $x)`
Defines the abscissa of the current position. If the passed value is negative, it is relative to the right of the page (or left if language is RTL). #### Tags:
see: | TCPDF::GetX(), TCPDF::GetY(), TCPDF::SetY(), TCPDF::SetXY()
since: | 1.2
access: | public
#### Parameters:
float | $x | The value of the abscissa.
[ Top ] ### method SetXY [line 5261]
`void SetXY( float $x, float $y)`
Defines the abscissa and ordinate of the current position. If the passed values are negative, they are relative respectively to the right and bottom of the page. #### Tags:
see: | TCPDF::SetX(), TCPDF::SetY()
since: | 1.2
access: | public
#### Parameters:
float | $x | The value of the abscissa
float | $y | The value of the ordinate
[ Top ] ### method SetY [line 5230]
`void SetY( float $y, [bool $resetx = true])`
Moves the current abscissa back to the left margin and sets the ordinate. If the passed value is negative, it is relative to the bottom of the page. #### Tags:
see: | TCPDF::GetX(), TCPDF::GetY(), TCPDF::SetY(), TCPDF::SetXY()
since: | 1.0
access: | public
#### Parameters:
float | $y | The value of the ordinate.
bool | $resetx | if true (default) reset the X position.
[ Top ] ### method set_mqr [line 4862]
`void set_mqr( boolean $mqr)`
Sets the current active configuration setting of magic_quotes_runtime (if the set_magic_quotes_runtime function exist) #### Tags:
since: | 4.6.025 (2009-08-17)
access: | public
#### Parameters:
boolean | $mqr | FALSE for off, TRUE for on.
[ Top ] ### method Skew [line 8235]
`void Skew( float $angle_x, float $angle_y, [int $x = ''], [int $y = ''])`
Skew. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $angle_x | angle in degrees between -90 (skew to the left) and 90 (skew to the right)
float | $angle_y | angle in degrees between -90 (skew to the bottom) and 90 (skew to the top)
int | $x | abscissa of the skewing center. default is current x position
int | $y | ordinate of the skewing center. default is current y position
[ Top ] ### method SkewX [line 8208]
`void SkewX( float $angle_x, [int $x = ''], [int $y = ''])`
Skew horizontally. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $angle_x | angle in degrees between -90 (skew to the left) and 90 (skew to the right)
int | $x | abscissa of the skewing center. default is current x position
int | $y | ordinate of the skewing center. default is current y position
[ Top ] ### method SkewY [line 8221]
`void SkewY( float $angle_y, [int $x = ''], [int $y = ''])`
Skew vertically. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
float | $angle_y | angle in degrees between -90 (skew to the bottom) and 90 (skew to the top)
int | $x | abscissa of the skewing center. default is current x position
int | $y | ordinate of the skewing center. default is current y position
[ Top ] ### method StarPolygon [line 9051]
`void StarPolygon( float $x0, float $y0, float $r, integer $nv, integer $ng, [ $angle = 0], [ $draw_circle = false], [string $style = ''], [array $line_style = array()], [array $fill_color = array()], [string $circle_style = ''], [array $circle_outLine_style = array()], [array $circle_fill_color = array()], float $angle:, boolean $draw_circle:)`
Draws a star polygon #### Tags:
since: | 2.1.000 (2008-01-08)
access: | public
#### Parameters:
float | $x0 | Abscissa of center point.
float | $y0 | Ordinate of center point.
float | $r | Radius of inscribed circle.
integer | $nv | Number of vertices.
integer | $ng | Number of gap (if ($ng % $nv = 1) then is a regular polygon).
float | $angle: | Angle oriented (anti-clockwise). Default value: 0.
boolean | $draw_circle: | Draw inscribed circle or not. Default value is false.
string | $style | Style of rendering. Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $line_style | Line style of polygon sides. Array with keys among the following: all: Line style of all sides. Array like for SetLineStyle. 0 to (n - 1): Line style of each side. Array like for SetLineStyle. If a key is not present or is null, not draws the side. Default value is default line style (empty array).
array | $fill_color | Fill color. Format: array(red, green, blue). Default value: default color (empty array).
string | $circle_style | Style of rendering of inscribed circle (if draws). Possible values are: D or empty string: Draw (default). F: Fill. DF or FD: Draw and fill. CNZ: Clipping mode (using the even-odd rule to determine which regions lie inside the clipping path). CEO: Clipping mode (using the nonzero winding number rule to determine which regions lie inside the clipping path).
array | $circle_outLine_style | Line style of inscribed circle (if draws). Array like for SetLineStyle. Default value: default line style (empty array).
array | $circle_fill_color | Fill color of inscribed circle (if draws). Format: array(red, green, blue). Default value: default color (empty array).
| $angle |
| $draw_circle |
[ Top ] ### method startPage [line 2393]
`void startPage( [string $orientation = ''], [mixed $format = ''])`
Starts a new page to the document. The page must be closed using the endPage() function. The origin of the coordinate system is at the top-left corner and increasing ordinates go downwards. #### Tags:
see: | TCPDF::endPage(), TCPDF::AddPage()
since: | 4.2.010 (2008-11-14)
access: | protected
#### Parameters:
string | $orientation | page orientation. Possible values are (case insensitive): P or PORTRAIT (default) L or LANDSCAPE
mixed | $format | The format used for pages. It can be either one of the following values (case insensitive) or a custom format in the form of a two-element array containing the width and the height (expressed in the unit given by unit). 4A0 2A0 A0 A1 A2 A3 A4 (default) A5 A6 A7 A8 A9 A10 B0 B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 C10 RA0 RA1 RA2 RA3 RA4 SRA0 SRA1 SRA2 SRA3 SRA4 LETTER LEGAL EXECUTIVE FOLIO
[ Top ] ### method startPageGroup [line 11108]
`void startPageGroup( [ $page = ''])`
#### Tags:
access: | public
#### Parameters:
| $page |
[ Top ] ### method startTransaction [line 15978]
`void startTransaction( )`
Stores a copy of the current TCPDF object used for undo operation. #### Tags:
since: | 4.5.029 (2009-03-19)
access: | public
[ Top ] ### method StartTransform [line 7973]
`void StartTransform( )`
Starts a 2D tranformation saving current graphic state. This function must be called before scaling, mirroring, translation, rotation and skewing. Use StartTransform() before, and StopTransform() after the transformations to restore the normal behavior. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
[ Top ] ### method StopTransform [line 7988]
`void StopTransform( )`
Stops a 2D tranformation restoring previous graphic state. This function must be called after scaling, mirroring, translation, rotation and skewing. Use StartTransform() before, and StopTransform() after the transformations to restore the normal behavior. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
[ Top ] ### method swapMargins [line 14898]
`void swapMargins( [boolean $reverse = true])`
Swap the left and right margins. #### Tags:
since: | 4.2.000 (2008-10-29)
access: | protected
#### Parameters:
boolean | $reverse | if true swap left and right margins.
[ Top ] ### method Text [line 3542]
`void Text( float $x, float $y, string $txt, [int $stroke = 0], [boolean $clip = false])`
Prints a character string. The origin is on the left of the first charcter, on the baseline. This method allows to place a string precisely on the page. #### Tags:
see: | TCPDF::Cell(), TCPDF::Write(), TCPDF::MultiCell(), WriteHTML(), WriteHTMLCell()
deprecated: | deprecated since version 4.3.005 (2008-11-25)
since: | 1.0
access: | public
#### Parameters:
float | $x | Abscissa of the origin
float | $y | Ordinate of the origin
string | $txt | String to print
int | $stroke | outline size in points (0 = disable)
boolean | $clip | if true activate clipping mode (you must call StartTransform() before this function and StopTransform() to stop the clipping tranformation).
[ Top ] ### method TextField [line 10459]
`void TextField( $name, $w, $h, [ $prop = array()], [ $opt = array()], [ $x = ''], [ $y = ''], [ $js = false])`
#### Tags:
access: | public
#### Parameters:
| $name |
| $w |
| $h |
| $prop |
| $opt |
| $x |
| $y |
| $js |
[ Top ] ### method Transform [line 8268]
`void Transform( $tm)`
Apply graphic transformations. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | protected
#### Parameters:
| $tm |
[ Top ] ### method Translate [line 8151]
`void Translate( int $t_x, int $t_y)`
Translate graphic object horizontally and vertically. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $t_x | movement to the right
int | $t_y | movement to the bottom
[ Top ] ### method TranslateX [line 8128]
`void TranslateX( int $t_x)`
Translate graphic object horizontally. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $t_x | movement to the right (or left for RTL)
[ Top ] ### method TranslateY [line 8139]
`void TranslateY( int $t_y)`
Translate graphic object vertically. #### Tags:
see: | TCPDF::StartTransform(), TCPDF::StopTransform()
since: | 2.1.000 (2008-01-07)
access: | public
#### Parameters:
int | $t_y | movement to the bottom
[ Top ] ### method unhtmlentities [line 7793]
`string unhtmlentities( $text_to_convert $text_to_convert)`
Reverse function for htmlentities. Convert entities in UTF-8. #### Tags:
return: | converted
access: | public
#### Parameters:
$text_to_convert | $text_to_convert | Text to convert.
[ Top ] ### method UniArrSubString [line 4571]
`Return UniArrSubString( string $uniarr, [int $start = ''], [int $end = ''])`
Extract a slice of the $uniarr array and return it as string. #### Tags:
return: | part of a string
since: | 4.5.037 (2009-04-07)
access: | public
#### Parameters:
string | $uniarr | The input array of characters.
int | $start | the starting element of $strarr.
int | $end | first element that will not be returned.
[ Top ] ### method unichr [line 4604]
`Returns unichr( int $c)`
Returns the unicode caracter specified by UTF-8 code #### Tags:
return: | the specified character.
author: | Miguel Perez, Nicola Asuni
since: | 2.3.000 (2008-03-05)
access: | public
#### Parameters:
int | $c | UTF-8 code
[ Top ] ### method UTF8ArrayToUniArray [line 4592]
`Return UTF8ArrayToUniArray( string $ta)`
Convert an array of UTF8 values to array of unicode characters #### Tags:
return: | array of unicode characters
since: | 4.5.037 (2009-04-07)
access: | public
#### Parameters:
string | $ta | The input array of UTF8 values.
[ Top ] ### method UTF8ArrSubString [line 4548]
`Return UTF8ArrSubString( string $strarr, [int $start = ''], [int $end = ''])`
Extract a slice of the $strarr array and return it as string. #### Tags:
return: | part of a string
access: | public
#### Parameters:
string | $strarr | The input array of characters.
int | $start | the starting element of $strarr.
int | $end | first element that will not be returned.
[ Top ] ### method utf8Bidi [line 9258]
`string utf8Bidi( array $ta, [string $str = ''], [bool $forcertl = false])`
Reverse the RLT substrings using the Bidirectional Algorithm (http://unicode.org/reports/tr9/). #### Tags:
author: | Nicola Asuni
since: | 2.4.000 (2008-03-06)
access: | protected
#### Parameters:
array | $ta | array of characters composing the string.
string | $str | string to process
bool | $forcertl | if 'R' forces RTL, if 'L' forces LTR
[ Top ] ### method UTF8StringToArray [line 7423]
`array UTF8StringToArray( string $str)`
Converts UTF-8 strings to codepoints array. Invalid byte sequences will be replaced with 0xFFFD (replacement character) Based on: http://www.faqs.org/rfcs/rfc3629.html
     	  Char. number range  |        UTF-8 octet sequence
           (hexadecimal)    |              (binary)
        --------------------+-----------------------------------------------
        0000 0000-0000 007F | 0xxxxxxx
        0000 0080-0000 07FF | 110xxxxx 10xxxxxx
        0000 0800-0000 FFFF | 1110xxxx 10xxxxxx 10xxxxxx
        0001 0000-0010 FFFF | 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
        ---------------------------------------------------------------------

       ABFN notation:
       ---------------------------------------------------------------------
       UTF8-octets = *( UTF8-char )
       UTF8-char   = UTF8-1 / UTF8-2 / UTF8-3 / UTF8-4
       UTF8-1      = %x00-7F
       UTF8-2      = %xC2-DF UTF8-tail

       UTF8-3      = %xE0 %xA0-BF UTF8-tail / %xE1-EC 2( UTF8-tail ) /
                     %xED %x80-9F UTF8-tail / %xEE-EF 2( UTF8-tail )
       UTF8-4      = %xF0 %x90-BF 2( UTF8-tail ) / %xF1-F3 3( UTF8-tail ) /
                     %xF4 %x80-8F 2( UTF8-tail )
       UTF8-tail   = %x80-BF
       ---------------------------------------------------------------------
#### Tags:
return: | containing codepoints (UTF-8 characters values)
author: | Nicola Asuni
since: | 1.53.0.TC005 (2005-01-05)
access: | protected
#### Parameters:
string | $str | string to process.
[ Top ] ### method utf8StrRev [line 9244]
`string utf8StrRev( string $str, [ $setbom = false], [bool $forcertl = false])`
Reverse the RLT substrings using the Bidirectional Algorithm (http://unicode.org/reports/tr9/). #### Tags:
author: | Nicola Asuni
since: | 2.1.000 (2008-01-08)
access: | protected
#### Parameters:
string | $str | string to manipulate.
bool | $forcertl | if 'R' forces RTL, if 'L' forces LTR
| $setbom |
[ Top ] ### method UTF8ToLatin1 [line 7530]
`string UTF8ToLatin1( string $str)`
Converts UTF-8 strings to Latin1 when using the standard 14 core fonts. #### Tags:
author: | Andrew Whitehead, Nicola Asuni
since: | 3.2.000 (2008-06-23)
access: | protected
#### Parameters:
string | $str | string to process.
[ Top ] ### method UTF8ToUTF16BE [line 7514]
`string UTF8ToUTF16BE( string $str, [boolean $setbom = true])`
Converts UTF-8 strings to UTF16-BE. #### Tags:
author: | Nicola Asuni
since: | 1.53.0.TC005 (2005-01-05)
access: | protected
uses: | TCPDF::UTF8StringToArray(), - arrUTF8ToUTF16BE()
#### Parameters:
string | $str | string to process.
boolean | $setbom | if true set the Byte Order Mark (BOM = 0xFEFF)
[ Top ] ### method Write [line 4214]
`mixed Write( float $h, string $txt, [mixed $link = ''], [int $fill = 0], [string $align = ''], [boolean $ln = false], [int $stretch = 0], [boolean $firstline = false], [boolean $firstblock = false], [float $maxh = 0])`
This method prints text from the current position. #### Tags:
return: | Return the number of cells or the remaining string if $firstline = true.
since: | 1.5
access: | public
#### Parameters:
float | $h | Line height
string | $txt | String to print
mixed | $link | URL or identifier returned by AddLink()
int | $fill | Indicates if the background must be painted (1) or transparent (0). Default value: 0.
string | $align | Allows to center or align the text. Possible values are: L or empty string: left align (default value) C: center R: right align J: justify
boolean | $ln | if true set cursor at the bottom of the line, otherwise set cursor at the top of the line.
int | $stretch | stretch carachter mode: 0 = disabled 1 = horizontal scaling only if necessary 2 = forced horizontal scaling 3 = character spacing only if necessary 4 = forced character spacing
boolean | $firstline | if true prints only the first line and return the remaining string.
boolean | $firstblock | if true the string is the starting of a line.
float | $maxh | maximum height. The remaining unprinted text will be returned. It should be >= $h and less then remaining space to the bottom of the page, or 0 for disable this feature.
[ Top ] ### method write1DBarcode [line 12062]
`void write1DBarcode( string $code, string $type, [int $x = ''], [int $y = ''], [int $w = ''], [int $h = ''], [float $xres = 0.4], [array $style = ''], [string $align = ''])`
Print a Linear Barcode. #### Tags:
author: | Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | public
#### Parameters:
string | $code | code to print
string | $type | type of barcode.
int | $x | x position in user units
int | $y | y position in user units
int | $w | width in user units
int | $h | height in user units
float | $xres | width of the smallest bar in user units
array | $style | array of options: string $style['position'] barcode position inside the specified width: L = left (default for LTR); C = center; R = right (default for RTL); S = stretch boolean $style['border'] if true prints a border around the barcode int $style['padding'] padding to leave around the barcode in user units array $style['fgcolor'] color array for bars and text mixed $style['bgcolor'] color array for background or false for transparent boolean $style["text"] boolean if true prints text below the barcode string $style['font'] font name for text int $style['fontsize'] font size for text int $style['stretchtext']: 0 = disabled; 1 = horizontal scaling only if necessary; 2 = forced horizontal scaling; 3 = character spacing only if necessary; 4 = forced character spacing
string | $align | Indicates the alignment of the pointer next to barcode insertion relative to barcode height. The value can be: T: top-right for LTR or top-left for RTL M: middle-right for LTR or middle-left for RTL B: bottom-right for LTR or bottom-left for RTL N: next line
[ Top ] ### method write2DBarcode [line 12313]
`void write2DBarcode( string $code, string $type, [int $x = ''], [int $y = ''], [int $w = ''], [int $h = ''], [array $style = ''], [string $align = ''])`
Print 2D Barcode. #### Tags:
author: | Nicola Asuni
since: | 4.5.037 (2009-04-07)
access: | public
#### Parameters:
string | $code | code to print
string | $type | type of barcode.
int | $x | x position in user units
int | $y | y position in user units
int | $w | width in user units
int | $h | height in user units
array | $style | array of options: boolean $style['border'] if true prints a border around the barcode int $style['padding'] padding to leave around the barcode in user units array $style['fgcolor'] color array for bars and text mixed $style['bgcolor'] color array for background or false for transparent
string | $align | Indicates the alignment of the pointer next to barcode insertion relative to barcode height. The value can be: T: top-right for LTR or top-left for RTL M: middle-right for LTR or middle-left for RTL B: bottom-right for LTR or bottom-left for RTL N: next line
[ Top ] ### method writeBarcode [line 12263]
`void writeBarcode( int $x, int $y, int $w, int $h, string $type, string $style, string $font, int $xres, string $code)`
This function is DEPRECATED, please use the new write1DBarcode() function. #### Tags:
see: | TCPDF::write1DBarcode()
deprecated: | deprecated since version 3.1.000 (2008-06-10)
access: | public
#### Parameters:
int | $x | x position in user units
int | $y | y position in user units
int | $w | width in user units
int | $h | height position in user units
string | $type | type of barcode (I25, C128A, C128B, C128C, C39)
string | $style | barcode style
string | $font | font for text
int | $xres | x resolution
string | $code | code to print
[ Top ] ### method writeDiskCache [line 15325]
`void writeDiskCache( $filename, mixed $data, [boolean $append = false], string $file)`
Writes data to a temporary file on filesystem. #### Tags:
since: | 4.5.000 (2008-12-31)
access: | protected
#### Parameters:
string | $file | file name
mixed | $data | data to write on file
boolean | $append | if true append data, false replace.
| $filename |
[ Top ] ### method writeHTML [line 13003]
`void writeHTML( string $html, [boolean $ln = true], [int $fill = false], [boolean $reseth = false], [boolean $cell = false], [string $align = ''])`
Allows to preserve some HTML formatting (limited support). IMPORTANT: The HTML must be well formatted - try to clean-up it using an application like HTML-Tidy before submitting. Supported tags are: a, b, blockquote, br, dd, del, div, dl, dt, em, font, h1, h2, h3, h4, h5, h6, hr, i, img, li, ol, p, pre, small, span, strong, sub, sup, table, tcpdf, td, th, thead, tr, tt, u, ul #### Tags:
access: | public
#### Parameters:
string | $html | text to display
boolean | $ln | if true add a new line after text (default = true)
int | $fill | Indicates if the background must be painted (true) or transparent (false).
boolean | $reseth | if true reset the last cell height (default false).
boolean | $cell | if true add the default cMargin space to each Write (default false).
string | $align | Allows to center or align the text. Possible values are: L : left align C : center R : right align '' : empty string : left for LTR or right for RTL
[ Top ] ### method writeHTMLCell [line 12551]
`void writeHTMLCell( float $w, float $h, float $x, float $y, [string $html = ''], [mixed $border = 0], [int $ln = 0], [int $fill = 0], [boolean $reseth = true], [string $align = ''], [boolean $autopadding = true])`
Prints a cell (rectangular area) with optional borders, background color and html text string. The upper-left corner of the cell corresponds to the current position. After the call, the current position moves to the right or to the next line. If automatic page breaking is enabled and the cell goes beyond the limit, a page break is done before outputting. #### Tags:
see: | Multicell(), TCPDF::writeHTML()
access: | public
uses: | TCPDF::MultiCell()
#### Parameters:
float | $w | Cell width. If 0, the cell extends up to the right margin.
float | $h | Cell minimum height. The cell extends automatically if needed.
float | $x | upper-left corner X coordinate
float | $y | upper-left corner Y coordinate
string | $html | html text to print. Default value: empty string.
mixed | $border | Indicates if borders must be drawn around the cell. The value can be either a number: 0: no border (default) 1: frame or a string containing some or all of the following characters (in any order): L: left T: top R: right B: bottom
int | $ln | Indicates where the current position should go after the call. Possible values are: 0: to the right (or left for RTL language) 1: to the beginning of the next line 2: below
int | $fill | Indicates if the cell background must be painted (1) or transparent (0). Default value: 0.
boolean | $reseth | if true reset the last cell height (default true).
string | $align | Allows to center or align the text. Possible values are: L : left align C : center R : right align '' : empty string : left for LTR or right for RTL
boolean | $autopadding | if true, uses internal padding and automatically adjust it to account for line width.
[ Top ] ### method _addfield [line 10031]
`void _addfield( $type, $name, $x, $y, $w, $h, $prop)`
#### Tags:
access: | protected
#### Parameters:
| $type |
| $name |
| $x |
| $y |
| $w |
| $h |
| $prop |
[ Top ] ### method _beginpage [line 7166]
`void _beginpage( [string $orientation = ''], [mixed $format = ''])`
Initialize a new page. #### Tags:
access: | protected
#### Parameters:
string | $orientation | page orientation. Possible values are (case insensitive): P or PORTRAIT (default) L or LANDSCAPE
mixed | $format | The format used for pages. It can be either one of the following values (case insensitive) or a custom format in the form of a two-element array containing the width and the height (expressed in the unit given by unit). 4A0 2A0 A0 A1 A2 A3 A4 (default) A5 A6 A7 A8 A9 A10 B0 B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 C0 C1 C2 C3 C4 C5 C6 C7 C8 C9 C10 RA0 RA1 RA2 RA3 RA4 SRA0 SRA1 SRA2 SRA3 SRA4 LETTER LEGAL EXECUTIVE FOLIO
[ Top ] ### method _datastring [line 7302]
`string _datastring( string $s)`
Format a data string for meta information #### Tags:
return: | escaped string.
access: | protected
#### Parameters:
string | $s | date string to escape.
[ Top ] ### method _datestring [line 7315]
`string _datestring( )`
Returns a formatted date for meta information #### Tags:
return: | escaped date string.
since: | 4.6.028 (2009-08-25)
access: | protected
[ Top ] ### method _destroy [line 5432]
`void _destroy( [boolean $destroyall = false], [boolean $preserve_objcopy = false])`
Unset all class variables except the following critical variables: internal_encoding, state, bufferlen, buffer and diskcache. #### Tags:
since: | 4.5.016 (2009-02-24)
access: | public
#### Parameters:
boolean | $destroyall | if true destroys all class variables, otherwise preserves critical variables.
boolean | $preserve_objcopy | if true preserves the objcopy variable
[ Top ] ### method _dochecks [line 5460]
`void _dochecks( )`
Check for locale-related bug #### Tags:
access: | protected
[ Top ] ### method _dolinethrough [line 7241]
`void _dolinethrough( int $x, int $y, string $txt)`
Line through text. #### Tags:
access: | protected
#### Parameters:
int | $x | X coordinate
int | $y | Y coordinate
string | $txt | text to linethrough
[ Top ] ### method _dolinethroughw [line 7268]
`void _dolinethroughw( int $x, int $y, $w, string $txt)`
Line through for rectangular text area. #### Tags:
since: | 4.8.008 (2009-09-29)
access: | protected
#### Parameters:
int | $x | X coordinate
int | $y | Y coordinate
string | $txt | text to linethrough
| $w |
[ Top ] ### method _dounderline [line 7229]
`void _dounderline( int $x, int $y, string $txt)`
Underline text. #### Tags:
access: | protected
#### Parameters:
int | $x | X coordinate
int | $y | Y coordinate
string | $txt | text to underline
[ Top ] ### method _dounderlinew [line 7254]
`void _dounderlinew( int $x, int $y, int $w)`
Underline for rectangular text area. #### Tags:
since: | 4.8.008 (2009-09-29)
access: | protected
#### Parameters:
int | $x | X coordinate
int | $y | Y coordinate
int | $w | width to underline
[ Top ] ### method _enddoc [line 7049]
`void _enddoc( )`
Output end of document (EOF). #### Tags:
access: | protected
[ Top ] ### method _endpage [line 7205]
`void _endpage( )`
Mark end of page. #### Tags:
access: | protected
[ Top ] ### method _escape [line 7291]
`string _escape( string $s)`
Add "\" before "\", "(" and ")" #### Tags:
return: | escaped string.
access: | protected
#### Parameters:
string | $s | string to escape.
[ Top ] ### method _escapetext [line 7340]
`string _escapetext( string $s)`
Format a text string #### Tags:
return: | escaped string.
access: | protected
#### Parameters:
string | $s | string to escape.
[ Top ] ### method _freadint [line 7280]
`4-byte _freadint( string $f)`
Read a 4-byte integer from file. #### Tags:
return: | integer
access: | protected
#### Parameters:
string | $f | file name.
[ Top ] ### method _generateencryptionkey [line 7913]
`void _generateencryptionkey( String $user_pass, String $owner_pass, String $protection)`
Compute encryption key #### Tags:
author: | Klemen Vodopivec
since: | 2.0.000 (2008-01-02)
access: | protected
#### Parameters:
String | $user_pass | user password
String | $owner_pass | user password
String | $protection | protection type
[ Top ] ### method _getfontpath [line 5476]
`string _getfontpath( )`
Return fonts path #### Tags:
access: | protected
[ Top ] ### method _JScolor [line 10007]
`void _JScolor( $color)`
#### Tags:
access: | protected
#### Parameters:
| $color |
[ Top ] ### method _md5_16 [line 7874]
`String _md5_16( string $str)`
Encrypts a string using MD5 and returns it's value as a binary string. #### Tags:
return: | MD5 encrypted binary string
author: | Klemen Vodopivec
since: | 2.0.000 (2008-01-02)
access: | protected
#### Parameters:
string | $str | input string
[ Top ] ### method _newobj [line 7215]
`int _newobj( )`
Begin a new object and return the object number. #### Tags:
return: | object number
access: | protected
[ Top ] ### method _objectkey [line 7806]
`void _objectkey( int $n)`
Compute encryption key depending on object number where the encrypted data is stored #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
#### Parameters:
int | $n | object number
[ Top ] ### method _out [line 7371]
`void _out( string $s)`
Output a string to the document. #### Tags:
access: | protected
#### Parameters:
string | $s | string to output.
[ Top ] ### method _outarc [line 11675]
`void _outarc( $x1, $y1, $x2, $y2, $x3, $y3)`
Output an arc #### Tags:
author: | Maxime Delorme, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | protected
#### Parameters:
| $x1 |
| $y1 |
| $x2 |
| $y2 |
| $x3 |
| $y3 |
[ Top ] ### method _outCurve [line 8441]
`void _outCurve( $x1, $y1, $x2, $y2, $x3, $y3)`
#### Tags:
access: | protected
#### Parameters:
| $x1 |
| $y1 |
| $x2 |
| $y2 |
| $x3 |
| $y3 |
[ Top ] ### method _outLine [line 8405]
`void _outLine( $x, $y)`
#### Tags:
access: | protected
#### Parameters:
| $x |
| $y |
[ Top ] ### method _outPoint [line 8391]
`void _outPoint( $x, $y)`
#### Tags:
access: | protected
#### Parameters:
| $x |
| $y |
[ Top ] ### method _outRect [line 8422]
`void _outRect( float $x, float $y, float $w, float $h, string $op)`
Draws a rectangle. #### Tags:
since: | 2.1.000 (2008-01-08)
access: | protected
#### Parameters:
float | $x | Abscissa of upper-left corner (or upper-right corner for RTL language).
float | $y | Ordinate of upper-left corner (or upper-right corner for RTL language).
float | $w | Width.
float | $h | Height.
string | $op | options
[ Top ] ### method _Ovalue [line 7887]
`String _Ovalue( String $user_pass, String $owner_pass)`
Compute O value (used for RC4 encryption) #### Tags:
return: | O value
author: | Klemen Vodopivec
since: | 2.0.000 (2008-01-02)
access: | protected
#### Parameters:
String | $user_pass | user password
String | $owner_pass | user password
[ Top ] ### method _parsejpeg [line 4912]
`array _parsejpeg( string $file)`
Extract info from a JPEG file without using the GD library. #### Tags:
return: | structure containing the image data
access: | protected
#### Parameters:
string | $file | image file to parse
[ Top ] ### method _parsepng [line 4938]
`array _parsepng( string $file)`
Extract info from a PNG file without using the GD library. #### Tags:
return: | structure containing the image data
access: | protected
#### Parameters:
string | $file | image file to parse
[ Top ] ### method _putannotsobjs [line 5659]
`void _putannotsobjs( )`
Output annotations objects for all pages. !!! THIS FUNCTION IS NOT YET COMPLETED !!! See section 12.5 of PDF 32000_2008 reference. #### Tags:
author: | Nicola Asuni
since: | 4.0.018 (2008-08-06)
access: | protected
[ Top ] ### method _putannotsrefs [line 5628]
`void _putannotsrefs( int $n)`
Output referencees to page annotations #### Tags:
author: | Nicola Asuni
since: | 4.7.000 (2008-08-29)
access: | protected
#### Parameters:
int | $n | page number
[ Top ] ### method _putAPXObject [line 6266]
`int _putAPXObject( [int $w = 0], [int $h = 0], [string $stream = ''])`
Put appearance streams XObject used to define annotation's appearance states #### Tags:
return: | object ID
since: | 4.8.001 (2009-09-09)
access: | protected
#### Parameters:
int | $w | annotation width
int | $h | annotation height
string | $stream | appearance stream
[ Top ] ### method _putbookmarks [line 9857]
`void _putbookmarks( )`
#### Tags:
access: | protected
[ Top ] ### method _putcatalog [line 6874]
`void _putcatalog( )`
Output Catalog. #### Tags:
access: | protected
[ Top ] ### method _putcidfont0 [line 6617]
`int _putcidfont0( array $font)`
Output CID-0 fonts. A Type 0 CIDFont contains glyph descriptions based on the Adobe Type 1 font format #### Tags:
return: | font object ID
author: | Andrew Whitehead, Nicola Asuni, Yukihiro Nakadaira
since: | 3.2.000 (2008-06-23)
access: | protected
#### Parameters:
array | $font | font data
[ Top ] ### method _putEmbeddedFiles [line 3511]
`void _putEmbeddedFiles( )`
Embedd the attached files. #### Tags:
see: | TCPDF::Annotation()
since: | 4.4.000 (2008-12-07)
access: | protected
[ Top ] ### method _putencryption [line 7815]
`void _putencryption( )`
Put encryption on PDF document. #### Tags:
since: | 2.0.000 (2008-01-02)
access: | protected
[ Top ] ### method _putextgstates [line 11337]
`void _putextgstates( )`
#### Tags:
access: | protected
[ Top ] ### method _putfonts [line 6294]
`void _putfonts( )`
Output fonts. #### Tags:
access: | protected
[ Top ] ### method _putfontwidths [line 6429]
`void _putfontwidths( array $font, [int $cidoffset = 0])`
Outputs font widths #### Tags:
author: | Nicola Asuni
since: | 4.4.000 (2008-12-07)
access: | protected
#### Parameters:
array | $font | font data
int | $cidoffset | offset for CID values
[ Top ] ### method _putheader [line 7041]
`void _putheader( )`
Output PDF header. #### Tags:
access: | protected
[ Top ] ### method _putimages [line 6682]
`void _putimages( )`
Output images. #### Tags:
access: | protected
[ Top ] ### method _putinfo [line 6840]
`void _putinfo( )`
Adds some Metadata information (see Chapter 10.2 of PDF Reference) #### Tags:
access: | protected
[ Top ] ### method _putjavascript [line 9947]
`void _putjavascript( )`
#### Tags:
access: | protected
[ Top ] ### method _putocg [line 11258]
`void _putocg( )`
#### Tags:
access: | protected
[ Top ] ### method _putpages [line 5487]
`void _putpages( )`
Output pages. #### Tags:
access: | protected
[ Top ] ### method _putresourcedict [line 6765]
`void _putresourcedict( )`
Output Resources Dictionary. #### Tags:
access: | protected
[ Top ] ### method _putresources [line 6806]
`void _putresources( )`
Output Resources. #### Tags:
access: | protected
[ Top ] ### method _putshaders [line 11625]
`void _putshaders( )`
Output shaders. #### Tags:
author: | Andreas Würmser, Nicola Asuni
since: | 3.1.000 (2008-06-09)
access: | protected
[ Top ] ### method _putsignature [line 10979]
`void _putsignature( )`
#### Tags:
access: | protected
[ Top ] ### method _putspotcolors [line 6737]
`void _putspotcolors( )`
Output Spot Colors Resources. #### Tags:
since: | 4.0.024 (2008-09-12)
access: | protected
[ Top ] ### method _putstream [line 7357]
`void _putstream( string $s)`
Output a stream. #### Tags:
access: | protected
#### Parameters:
string | $s | string to output.
[ Top ] ### method _puttrailer [line 7027]
`void _puttrailer( )`
Output trailer. #### Tags:
access: | protected
[ Top ] ### method _puttruetypeunicode [line 6528]
`int _puttruetypeunicode( array $font)`
Adds unicode fonts. Based on PDF Reference 1.3 (section 5) #### Tags:
return: | font object ID
author: | Nicola Asuni
since: | 1.52.0.TC005 (2005-01-05)
access: | protected
#### Parameters:
array | $font | font data
[ Top ] ### method _putviewerpreferences [line 6957]
`void _putviewerpreferences( )`
Output viewer preferences. #### Tags:
author: | Nicola asuni
since: | 3.1.000 (2008-06-09)
access: | protected
[ Top ] ### method _putxobjectdict [line 6754]
`void _putxobjectdict( )`
Output object dictionary for images. #### Tags:
access: | protected
[ Top ] ### method _RC4 [line 7834]
`String _RC4( string $key, String $text)`
Returns the input text exrypted using RC4 algorithm and the specified key. RC4 is the standard encryption algorithm used in PDF format #### Tags:
return: | encrypted text
author: | Klemen Vodopivec
since: | 2.0.000 (2008-01-02)
access: | protected
#### Parameters:
string | $key | encryption key
String | $text | input text to be encrypted
[ Top ] ### method _textstring [line 7326]
`string _textstring( string $s)`
Format a text string for meta information #### Tags:
return: | escaped string.
access: | protected
#### Parameters:
string | $s | string to escape.
[ Top ] ### method _toJPEG [line 4896]
`void _toJPEG( image $image, string $file)`
Convert the loaded php image to a JPEG and then return a structure for the PDF creator. This function requires GD library and write access to the directory defined on K_PATH_CACHE constant. #### Tags:
access: | protected
#### Parameters:
string | $file | Image file name.
image | $image | Image object. return image JPEG image object.
[ Top ] ### method _Uvalue [line 7900]
`String _Uvalue( )`
Compute U value (used for RC4 encryption) #### Tags:
return: | U value
author: | Klemen Vodopivec
since: | 2.0.000 (2008-01-02)
access: | protected
[ Top ] Documentation generated on Wed, 30 Sep 2009 11:18:23 +0200 by phpDocumentor 1.4.1